﻿'Programed by NAS6

Imports System.Security.Permissions



'操作パッド
Public Class Form1
    Public MsgCue As New MyQueue(Of PadMsg)
    Public SenderCue As New MyQueue(Of PadObject)
    Public EventArgsCue As New MyQueue(Of PadEventArgs)

    <SecurityPermission(SecurityAction.Demand, Flags:=SecurityPermissionFlag.UnmanagedCode)> _
    Protected Overrides Sub WndProc(ByRef m As System.Windows.Forms.Message)
        Const WM_SYSCOMMAND As Integer = &H112
        Const SC_CLOSE As Long = &HF060L

        If m.Msg = WM_SYSCOMMAND AndAlso _
            (m.WParam.ToInt64() And &HFFF0L) = SC_CLOSE Then
            MsgCue.Enqueue(New PadMsg(ENumPadMsg.MSG_CLOSE))
            SenderCue.Enqueue(New PadObject)
            EventArgsCue.Enqueue(New PadEventArgs)
            Return
        End If

        MyBase.WndProc(m)
    End Sub

    'ResetButtonSendMsg
    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        MsgCue.Enqueue(New PadMsg(ENumPadMsg.MSG_BTN1_CLK))
        SenderCue.Enqueue(New PadObject(sender))
        EventArgsCue.Enqueue(New PadEventArgs(e))
    End Sub

    'TurnButtonSendMsg
    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        MsgCue.Enqueue(New PadMsg(ENumPadMsg.MSG_BTN2_CLK))
        SenderCue.Enqueue(New PadObject(sender))
        EventArgsCue.Enqueue(New PadEventArgs(e))
    End Sub

    'StopButtonSendMsg
    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click
        MsgCue.Enqueue(New PadMsg(ENumPadMsg.MSG_BTN3_CLK))
        SenderCue.Enqueue(New PadObject(sender))
        EventArgsCue.Enqueue(New PadEventArgs(e))
    End Sub

    'StartButtonSendMsg
    Private Sub ButtonSTART_Click(sender As System.Object, e As System.EventArgs) Handles ButtonSTART.Click
        MsgCue.Enqueue(New PadMsg(ENumPadMsg.MSG_BTNSTART_CLK))
        SenderCue.Enqueue(New PadObject(sender))
        EventArgsCue.Enqueue(New PadEventArgs(e))
    End Sub

    'RunButtonSendMsg
    Private Sub ButtonRUN_Click(sender As System.Object, e As System.EventArgs) Handles ButtonRUN.Click
        MsgCue.Enqueue(New PadMsg(ENumPadMsg.MSG_BTNRUN_CLK))
        SenderCue.Enqueue(New PadObject(sender))
        EventArgsCue.Enqueue(New PadEventArgs(e))
    End Sub

    'PauseButtonSendMsg
    Private Sub ButtonPAUSE_Click(sender As System.Object, e As System.EventArgs) Handles ButtonPAUSE.Click
        MsgCue.Enqueue(New PadMsg(ENumPadMsg.MSG_BTNPAUSE_CLK))
        SenderCue.Enqueue(New PadObject(sender))
        EventArgsCue.Enqueue(New PadEventArgs(e))
    End Sub

    'RadioButtonSendMsg
    Private Sub RadioButton1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButton1.CheckedChanged
        MsgCue.Enqueue(New PadMsg(ENumPadMsg.MSG_RBTN_CHG))
        SenderCue.Enqueue(New PadObject(sender))
        EventArgsCue.Enqueue(New PadEventArgs(e))
    End Sub

    'CheckBoxSendMsg
    Private Sub CheckBox1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox1.CheckedChanged
        MsgCue.Enqueue(New PadMsg(ENumPadMsg.MSG_CBOX_CHG))
        SenderCue.Enqueue(New PadObject(sender))
        EventArgsCue.Enqueue(New PadEventArgs(e))
    End Sub

    'ListBoxSendMsg
    Private Sub ListBox1_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ListBox1.SelectedIndexChanged
        MsgCue.Enqueue(New PadMsg(ENumPadMsg.MSG_LBOX_CHG))
        SenderCue.Enqueue(New PadObject(sender))
        EventArgsCue.Enqueue(New PadEventArgs(e))
    End Sub
End Class

'PadMsg列挙体
Public Enum ENumPadMsg As Integer
    MSG_NULL = 0
    MSG_BTN1_CLK = 1
    MSG_BTN2_CLK = 2
    MSG_BTN3_CLK = 3
    MSG_BTNSTART_CLK = 4
    MSG_BTNRUN_CLK = 5
    MSG_BTNPAUSE_CLK = 6
    MSG_RBTN_CHG = 7
    MSG_CBOX_CHG = 8
    MSG_LBOX_CHG = 9
    MSG_CLOSE = 10
End Enum

Public Class PadMsg
    Implements IComparable
    Implements ICloneable

    Public Msg As ENumPadMsg

    Public Function Clone() As Object Implements ICloneable.Clone
        Dim ret As New PadMsg
        ret.Msg = Me.Msg
        Return ret
    End Function

    Public Function CompareTo(obj As Object) As Integer Implements IComparable.CompareTo
        CompareTo = 0
        Dim lh As PadMsg = Me
        Dim rh As PadMsg = obj
        If Not lh.Msg = rh.Msg Then
            CompareTo = CompareTo Or (1 << 0)
        End If
    End Function

    Public Overrides Function Equals(obj As Object) As Boolean
        Dim ret As Integer = CompareTo(obj)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Shared Operator =(ByVal lh As PadMsg, ByVal rh As PadMsg) As Boolean
        Dim ret As Integer = lh.CompareTo(rh)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Operator

    Public Shared Operator <>(ByVal lh As PadMsg, ByVal rh As PadMsg) As Boolean
        Return (Not lh = rh)
    End Operator


    Public Sub New()
        Msg = ENumPadMsg.MSG_NULL
    End Sub

    Public Sub New(ByVal pmsg As ENumPadMsg)
        Msg = pmsg
    End Sub

End Class


Public Class PadObject
    Implements IComparable
    Implements ICloneable

    Public Obj As System.Object

    Public Function Clone() As Object Implements ICloneable.Clone
        Dim ret As New PadObject
        ret.Obj = Me.Obj
        Return ret
    End Function

    Public Function CompareTo(obj As Object) As Integer Implements IComparable.CompareTo
        CompareTo = 0
        Dim lh As PadObject = Me
        Dim rh As PadObject = obj
        If Not lh.Obj = rh.Obj Then
            CompareTo = CompareTo Or (1 << 0)
        End If
    End Function

    Public Overrides Function Equals(obj As Object) As Boolean
        Dim ret As Integer = CompareTo(obj)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Shared Operator =(ByVal lh As PadObject, ByVal rh As PadObject) As Boolean
        Dim ret As Integer = lh.CompareTo(rh)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Operator

    Public Shared Operator <>(ByVal lh As PadObject, ByVal rh As PadObject) As Boolean
        Return (Not lh = rh)
    End Operator


    Public Sub New()
        Obj = Nothing
    End Sub

    Public Sub New(ByVal pobj As System.Object)
        Obj = pobj
    End Sub

End Class


Public Class PadEventArgs
    Implements IComparable
    Implements ICloneable

    Public e As System.EventArgs

    Public Function Clone() As Object Implements ICloneable.Clone
        Dim ret As New PadEventArgs
        ret.e = Me.e
        Return ret
    End Function

    Public Function CompareTo(obj As Object) As Integer Implements IComparable.CompareTo
        CompareTo = 0
        Dim lh As PadEventArgs = Me
        Dim rh As PadEventArgs = obj
        If Not lh.e.Equals(rh.e) Then
            CompareTo = CompareTo Or (1 << 0)
        End If
    End Function

    Public Overrides Function Equals(obj As Object) As Boolean
        Dim ret As Integer = CompareTo(obj)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Shared Operator =(ByVal lh As PadEventArgs, ByVal rh As PadEventArgs) As Boolean
        Dim ret As Integer = lh.CompareTo(rh)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Operator

    Public Shared Operator <>(ByVal lh As PadEventArgs, ByVal rh As PadEventArgs) As Boolean
        Return (Not lh = rh)
    End Operator


    Public Sub New()
        e = Nothing
    End Sub

    Public Sub New(ByVal pe As System.EventArgs)
        e = pe
    End Sub

End Class

