﻿'Programed by NAS6

'透視射影
Public Class Frustum
    Implements IComparable
    Implements ICloneable

    Public n As Double
    Public f As Double
    Public l As Double
    Public r As Double
    Public b As Double
    Public t As Double


    Public Function Clone() As Object Implements ICloneable.Clone
        Dim ret As New Frustum
        ret.n = Me.n
        ret.f = Me.f
        ret.l = Me.l
        ret.r = Me.r
        ret.b = Me.b
        ret.t = Me.t
        Return ret
    End Function

    Public Function CompareTo(obj As Object) As Integer Implements IComparable.CompareTo
        CompareTo = 0
        Dim lh As Frustum = Me
        Dim rh As Frustum = obj
        If Not (lh.n = rh.n) Then
            CompareTo = CompareTo Or (1 << 0)
        End If
        If Not (lh.f = rh.f) Then
            CompareTo = CompareTo Or (1 << 1)
        End If
        If Not (lh.l = rh.l) Then
            CompareTo = CompareTo Or (1 << 2)
        End If
        If Not (lh.r = rh.r) Then
            CompareTo = CompareTo Or (1 << 3)
        End If
        If Not (lh.b = rh.b) Then
            CompareTo = CompareTo Or (1 << 4)
        End If
        If Not (lh.t = rh.t) Then
            CompareTo = CompareTo Or (1 << 5)
        End If
    End Function

    Public Overrides Function Equals(obj As Object) As Boolean
        Dim ret As Integer = CompareTo(obj)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Shared Operator =(ByVal lh As Frustum, ByVal rh As Frustum) As Boolean
        Dim ret As Integer = lh.CompareTo(rh)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Operator

    Public Shared Operator <>(ByVal lh As Frustum, ByVal rh As Frustum) As Boolean
        Return (Not lh = rh)
    End Operator

    Public Sub New()
        n = 1.0
        f = 10.0
        l = -5.0
        r = 5.0
        b = -5.0
        t = 5.0
    End Sub

    Public Sub New(ByVal pn As Double, ByVal pf As Double, ByVal pl As Double, ByVal pr As Double, ByVal pb As Double, ByVal pt As Double)
        n = pn
        f = pf
        l = pl
        r = pr
        b = pb
        t = pt
    End Sub

    '透視射影
    Public Function Frustum(ByVal v As Vector) As Vector
        Dim MatWk As New Matrix(4)
        MatWk.x(0).x(0) = 0.0
        MatWk.x(0).x(1) = 0.0
        MatWk.x(0).x(2) = 0.0
        MatWk.x(0).x(3) = -1.0
        MatWk.x(1).x(0) = 0.0
        MatWk.x(1).x(1) = (2.0 * n) / (r - l)
        MatWk.x(1).x(2) = 0.0
        MatWk.x(1).x(3) = (r + l) / (r - l)
        MatWk.x(2).x(0) = 0.0
        MatWk.x(2).x(1) = 0.0
        MatWk.x(2).x(2) = (2.0 * n) / (t - b)
        MatWk.x(2).x(3) = (t + b) / (t - b)
        MatWk.x(3).x(0) = -(2.0 * n * f) / (f - n)
        MatWk.x(3).x(1) = 0.0
        MatWk.x(3).x(2) = 0.0
        MatWk.x(3).x(3) = -(f + n) / (f - n)
        Dim VecWK As Vector = MatWk * v
        Return VecWK
    End Function

    '逆透視射影
    Public Function InvFrustum(ByVal v As Vector) As Vector
        Dim dt As Double
        Dim MatWk As New Matrix(4)
        MatWk.x(0).x(0) = 0.0
        MatWk.x(0).x(1) = 0.0
        MatWk.x(0).x(2) = 0.0
        MatWk.x(0).x(3) = -1.0
        MatWk.x(1).x(0) = 0.0
        MatWk.x(1).x(1) = (2.0 * n) / (r - l)
        MatWk.x(1).x(2) = 0.0
        MatWk.x(1).x(3) = (r + l) / (r - l)
        MatWk.x(2).x(0) = 0.0
        MatWk.x(2).x(1) = 0.0
        MatWk.x(2).x(2) = (2.0 * n) / (t - b)
        MatWk.x(2).x(3) = (t + b) / (t - b)
        MatWk.x(3).x(0) = -(2.0 * n * f) / (f - n)
        MatWk.x(3).x(1) = 0.0
        MatWk.x(3).x(2) = 0.0
        MatWk.x(3).x(3) = -(f + n) / (f - n)
        MatWk = MatWk.InverseMat(dt)
        Dim VecWK As Vector = MatWk * v
        Return VecWK
    End Function
End Class
