'Programed by NAS6
'参考文献
'天体の位置計算増補版　長沢工　地人書館
'理科年表平成8年1996年　国立天文台　丸善
'理科年表平成25年2013年　国立天文台　丸善






''' <summary>
''' 基底 Game クラスから派生した、ゲームのメイン クラスです。
''' </summary>
''' 
Imports System
Imports System.IO

'main
Public Class Game1
    Inherits Microsoft.Xna.Framework.Game

    Private WithEvents graphics As GraphicsDeviceManager
    Private WithEvents spriteBatch As SpriteBatch
    Private font As SpriteFont
    Private titleFont As SpriteFont
    Private gradientFont As SpriteFont
    Private outlineFont As SpriteFont

    Private Pad As Form1

    'テクスチャ
    Private back As Texture2D
    Private white As Texture2D
    Private pointer As Texture2D
    Private center As Texture2D
    Private pos As Vector2

    '開始フラグ
    Private bStart As Boolean = False


    Private planet() As Planet                  '惑星データ
    Private mp() As MassPoint                   '質点データ
    Private dat As New DateTime(2000, 1, 1)     '日付データ
    Private time As Double                      '時間データ
    Private dt As Double                        'デルタＴ

    '回転角周辺
    Private theta As Double
    Private theta2 As Double
    Private theta3 As Double
    Private verror As Double
    Private ntime As Double
    Private hialt As Double
    Private hialt2 As Double
    Private rgt As Boolean
    Private rgt2 As Boolean
    Private rgt3 As Boolean
    Private rgt4 As Boolean
    Private hialttmp As Double
    Private thetatmp As Double

    Private col As Integer = 0

    Private runt As String
    Private speed As Double                     'デルタＴ
    Private stopw As Stopwatch = New Stopwatch



    Private ts As TimeSpan = New TimeSpan()

    Private bfst As Boolean
    Private bld As Boolean = True


    Private xxx As Vector
    Private dms As Integer      '空間次元





    Private r3d As Render3D     'レンダリング本体
    Private Sphr() As Sphere    '球体データ
    Private Line() As Line      '線分データ

    Private Camera As New Local 'カメラ行列

    Private MC As MouseCamera   'マウスカメラデータ

    Private Const AU As Double = 149597870700.0     '天文単位
    Private Const DZ As Double = AU * 100.0         '初期z座標

    'Private Const CR As Double = 1.0
    Private Const CR As Double = AU / 1000000.0     'Range
    Private Const CB As Double = 8.0                'Base    

    Private Const YR As Double = 0.05               'ヨー倍率
    Private Const PR As Double = 0.05               'ピッチ倍率
    Private Const RR As Double = 0.05               'ロール倍率
    Private Const ZR As Double = AU * 2.5           'ズーム倍率    


    Private BK As Boolean = True                    'ケプラー方程式

    Private Const Arrive As Double = AU / 5.0      '到着係数

    Private el As Euler = New Euler 'オイラー法本体
    Private rk As RngKt = New RngKt 'ルンゲクッタ法本体

    Private Const PlanetsNum = 15   '小惑星を含む惑星数  
    Private Const PlanetsANum = 9   '惑星数

    Private asteroid As Boolean = False '小惑星フラグ

  
    Public Sub New()
        graphics = New GraphicsDeviceManager(Me)
        Content.RootDirectory = "Content"
        graphics.PreferredBackBufferWidth = 360
        graphics.PreferredBackBufferHeight = 360
    End Sub

    ''' <summary>
    ''' ゲームの開始前に実行する必要がある初期化を実行できるようにします。
    ''' ここで、要求されたサービスを問い合わせて、非グラフィック関連のコンテンツをロードできます。
    ''' MyBase.Initialize を呼び出すと、任意のコンポーネントが列挙され、
    ''' 初期化もされます
    ''' </summary>
    Protected Overrides Sub Initialize()
        ' TODO: ここに初期化ロジックを追加します。
        'ウィンドウタイトル
        MyBase.Window.Title = "SolarSystem3DXNA"
        pos = New Vector2(0, 0) 'マウスポインタ座標

        'マウスカメラの初期設定
        Dim LocalMat As New Matrix(4)
        LocalMat = LocalMat.UnitMat()
        MC = New MouseCamera(LocalMat, GraphicsDevice.Viewport.Width, GraphicsDevice.Viewport.Height, YR, PR, RR, ZR)

        MyBase.Initialize()

        '操作パッド初期設定
        Pad = New Form1
        Pad.StartPosition = System.Windows.Forms.FormStartPosition.Manual
        Pad.Location = New System.Drawing.Point(MyBase.Window.ClientBounds.Right + 20, MyBase.Window.ClientBounds.Top - 30)
        Pad.ListBox1.SelectedIndex = 0
        Pad.Show()

        '検証テスト
        If Not BK Then
            InitRelative(True)  '相対論
        Else
            InitKepler(True)    'ケプラー方程式
        End If

        bld = False
    End Sub

    ''' <summary>
    ''' LoadContent はゲームごとに 1 回呼び出され、ここですべてのコンテンツを
    ''' 読み込みます。
    ''' </summary>
    Protected Overrides Sub LoadContent()
        ' 新規の SpriteBatch を作成します。これはテクスチャーの描画に使用できます。
        spriteBatch = New SpriteBatch(GraphicsDevice)
        Using Stream As Stream = File.OpenRead("Content\Center.png")
            center = Texture2D.FromStream(GraphicsDevice, Stream)
        End Using
        Using Stream As Stream = File.OpenRead("Content\Cursor.png")
            pointer = Texture2D.FromStream(GraphicsDevice, Stream)
        End Using
        Using Stream As Stream = File.OpenRead("Content\White.png")
            white = Texture2D.FromStream(GraphicsDevice, Stream)
        End Using
        Using Stream As Stream = File.OpenRead("Content\mimiback.png")
            back = Texture2D.FromStream(GraphicsDevice, Stream)
        End Using
        'フォントデータの読み込み
        font = Content.Load(Of SpriteFont)("Font")
        titleFont = Content.Load(Of SpriteFont)("TitleFont")
        gradientFont = Content.Load(Of SpriteFont)("GradientFont")
        outlineFont = Content.Load(Of SpriteFont)("OutlineFont")



 
        ' TODO: Me.Content を使用して、ここにゲーム コンテンツをロードします。
    End Sub

    ''' <summary>
    ''' UnloadContent はゲームごとに 1 回呼び出され、ここですべてのコンテンツを
    ''' アンロードします。
    ''' </summary>
    Protected Overrides Sub UnloadContent()
        ' TODO: ここで ContentManager 以外のすべてのコンテンツをアンロードします。
    End Sub

    ''' <summary>
    ''' ワールドの更新、衝突判定、入力値の取得、オーディオの再生などの
    ''' ゲーム ロジックを、実行します。
    ''' </summary>
    ''' <param name="gameTime">ゲームの瞬間的なタイミング情報</param>
    Protected Overrides Sub Update(ByVal gameTime As GameTime)
        ' ゲームの終了条件をチェックします。
        If GamePad.GetState(PlayerIndex.One).Buttons.Back = ButtonState.Pressed Then
            Me.Exit()
        End If

        Dim i As Integer

        'マウスポインタ位置更新
        pos.X = Mouse.GetState().X
        pos.Y = Mouse.GetState().Y

        'マウスポインタが画面範囲内ならマウス処理
        If 0 < pos.X And pos.X < 360 And 0 < pos.Y And pos.Y < 360 Then
            MC.MouseDown(Mouse.GetState())
            MC.MouseMove(Mouse.GetState())
            MC.MouseUp(Mouse.GetState())
        End If


        '操作パッド位置更新
        Pad.Location = New System.Drawing.Point(MyBase.Window.ClientBounds.Right + 20, MyBase.Window.ClientBounds.Top - 30)

        '操作パッドメッセージ処理
        While Pad.MsgCue.Count
            If Not bStart Then
                Select Case Pad.MsgCue.buf(0).Msg
                    Case ENumPadMsg.MSG_NULL
                        Exit Select
                    Case ENumPadMsg.MSG_BTN1_CLK
                        ButtonRESET_Click(Pad.SenderCue.buf(0).Obj, Pad.EventArgsCue.buf(0).e)
                        Exit Select
                    Case ENumPadMsg.MSG_BTN2_CLK
                        ButtonTURN_Click(Pad.SenderCue.buf(0).Obj, Pad.EventArgsCue.buf(0).e)
                        Exit Select
                    Case ENumPadMsg.MSG_BTN3_CLK
                        ButtonSTOP_Click(Pad.SenderCue.buf(0).Obj, Pad.EventArgsCue.buf(0).e)
                        Exit Select
                    Case ENumPadMsg.MSG_BTNSTART_CLK
                        ButtonSTART_Click(Pad.SenderCue.buf(0).Obj, Pad.EventArgsCue.buf(0).e)
                        Exit Select
                    Case ENumPadMsg.MSG_BTNRUN_CLK
                        ButtonRUN_Click(Pad.SenderCue.buf(0).Obj, Pad.EventArgsCue.buf(0).e)
                        Exit Select
                    Case ENumPadMsg.MSG_BTNPAUSE_CLK
                        ButtonPAUSE_Click(Pad.SenderCue.buf(0).Obj, Pad.EventArgsCue.buf(0).e)
                        Exit Select
                    Case ENumPadMsg.MSG_RBTN_CHG
                        RadioButton1_CheckedChanged(Pad.SenderCue.buf(0).Obj, Pad.EventArgsCue.buf(0).e)
                        Exit Select
                    Case ENumPadMsg.MSG_CBOX_CHG
                        CheckBox1_CheckedChanged(Pad.SenderCue.buf(0).Obj, Pad.EventArgsCue.buf(0).e)
                        Exit Select
                    Case ENumPadMsg.MSG_LBOX_CHG
                        ListBox1_CheckedChanged(Pad.SenderCue.buf(0).Obj, Pad.EventArgsCue.buf(0).e)
                        Exit Select
                    Case ENumPadMsg.MSG_CLOSE
                        Me.Exit()
                        Exit Select
                End Select
            End If
            Pad.MsgCue.Remove(0)
            Pad.SenderCue.Remove(0)
            Pad.EventArgsCue.Remove(0)
        End While



        ' TODO: ここにゲームのアップデート ロジックを追加します。
        MyBase.Update(gameTime)
    End Sub

    ''' <summary>
    ''' ゲームが自身を描画するためのメソッドです。
    ''' </summary>
    ''' <param name="gameTime">ゲームの瞬間的なタイミング情報</param>
    Protected Overrides Sub Draw(ByVal gameTime As GameTime)
        GraphicsDevice.Clear(Color.Black)

        spriteBatch.Begin()

        '検証テスト
        If Not BK Then
            UpdateFrameRelative(spriteBatch)    '相対論
        Else
            UpdateFrameKepler(spriteBatch)      'ケプラー方程式
        End If

        'テクスチャ描画
        spriteBatch.Draw(center, New Vector2(166.0, 166.0), Color.White)
        spriteBatch.Draw(pointer, pos, Color.White)

        spriteBatch.End()
        ' TODO: ここに描画コードを追加します。
        MyBase.Draw(gameTime)
    End Sub

    'フォント初期設定
    Public Sub InitParagraph(ByVal pg As Paragraph)
        Select Case pg.FontType
            Case MessageFontType.Normal
                pg.Font = font
                Exit Select
            Case MessageFontType.Title
                pg.Font = titleFont
                Exit Select
            Case MessageFontType.Gradient
                pg.Font = gradientFont
                Exit Select
            Case MessageFontType.Outline
                pg.Font = outlineFont
                Exit Select
        End Select
        pg.Size = pg.Font.MeasureString(pg.Text)
    End Sub

    '視点選択リストボックス
    Private Sub ListBox1_CheckedChanged(sender As System.Object, e As System.EventArgs)
        Dim pn As Integer
        If asteroid Then
            pn = PlanetsNum
        Else
            pn = PlanetsANum
        End If
        If pn < Pad.ListBox1.SelectedIndex Then
            Pad.ListBox1.ClearSelected()
            Pad.ListBox1.SelectedIndex = 0
        End If
    End Sub

    '小惑星選択チェックボックス
    Private Sub CheckBox1_CheckedChanged(sender As System.Object, e As System.EventArgs)
        Pad.ListBox1.ClearSelected()
        Pad.ListBox1.SelectedIndex = 0

        asteroid = Pad.CheckBox1.Checked
        If Not BK Then
            InitRelative(False)
        Else
            InitKepler(False)
        End If
    End Sub

    Private Sub ButtonSTART_Click(sender As System.Object, e As System.EventArgs)
        If Not BK Then
            InitRelative(True)
        Else
            InitKepler(True)
        End If
    End Sub

    Private Sub ButtonRUN_Click(sender As System.Object, e As System.EventArgs)
        dt = 60.0 * 60.0 * Double.Parse(Pad.TextBoxSpeed.Text)
        speed = dt
        Dim i As Integer
        If Not BK Then
            Dim pn As Integer
            If asteroid Then
                pn = PlanetsNum
            Else
                pn = PlanetsANum
            End If
            Dim pmp(pn - 1) As MassPoint
            For i = 0 To pn - 1
                pmp(i) = New MassPoint(3)
                pmp(i) = rk.mp(i).Clone()
            Next
            rk.Init(pmp, dt)
        End If
    End Sub

    Private Sub ButtonPAUSE_Click(sender As System.Object, e As System.EventArgs)
        speed = dt
        dt = 0.0
    End Sub


    Private Sub ButtonRESET_Click(sender As System.Object, e As System.EventArgs)
        Dim m As New Matrix(4)
        m = m.UnitMat()
        m.x(3).x(0) = DZ
        r3d.CameraMat = m.Clone()
        MC.m = r3d.LookAtMat(0, True)
        r3d.CameraMat = MC.m.Clone()
        MC.Accel = 0.0
    End Sub

    Private Sub ButtonTURN_Click(sender As System.Object, e As System.EventArgs)
        Dim i As Integer
        Dim j As Integer
        For i = 1 To 3
            For j = 1 To 3
                MC.m.x(i).x(j) *= -1.0
            Next
        Next
    End Sub

    Private Sub ButtonSTOP_Click(sender As System.Object, e As System.EventArgs)
        MC.Accel = 0.0
    End Sub

    '相対論ケプラー方程式選択ラジオボタン
    Private Sub RadioButton1_CheckedChanged(sender As System.Object, e As System.EventArgs)
        If Not bld Then
            BK = Pad.RadioButton1.Checked
            If Not BK Then
                InitRelative(False)
            Else
                InitKepler(False)
            End If
        End If
    End Sub

    'Dash&Walkレート
    Private Sub SetRate()
        Dim i As Integer
        Dim j As Integer
        Dim min As Double = Double.MaxValue
        Dim pn As Integer
        If asteroid Then
            pn = PlanetsNum
        Else
            pn = PlanetsANum
        End If
        For i = 0 To pn - 1
            Dim dt As Double
            Dim MatWK As New Matrix(4)
            '惑星座標取得
            MatWK = r3d.Camera.Mat()
            MatWK *= r3d.CameraMat
            MatWK = MatWK.InverseMat(dt)
            Dim MatWK2 As Matrix = MatWK.Clone()
            MatWK *= r3d.Sphr.buf(i).Local.Mat()
            MatWK = MatWK.Homogeneous()

            Dim pos As Vector = MatWK.Pos()
            Dim d As Double = pos.Abs() '太陽惑星間距離

            If d < min Then
                min = d
                j = i
            End If
        Next
        '惑星到着処理
        If Pad.ListBox1.SelectedIndex <= pn Then
            If 0 < Pad.ListBox1.SelectedIndex Then
                i = Pad.ListBox1.SelectedIndex - 1
                If min < Arrive * r3d.Sphr.buf(i).v.r / r3d.Sphr.buf(0).v.r Then
                    MC.Accel = 0.0
                    Pad.ListBox1.SelectedIndex = 0
                End If
            End If
        End If
        'Dash&Walk処理
        Dim mm As Double = Arrive * r3d.Sphr.buf(j).v.r / r3d.Sphr.buf(0).v.r
        If min < mm Then
            min = mm
        End If
        If DZ / 3.0 < min Then
            min = DZ / 3.0
        End If
        MC.ZoomRate = (min / (DZ / 3.0)) * ZR
    End Sub

    '情報を操作パッドに表示
    Private Sub SetInfoKepler()
        Dim mat As Matrix = r3d.Camera.Mat()
        mat *= r3d.CameraMat
        mat = mat.Homogeneous()
        Dim pos As Vector = mat.Pos()
        pos = pos.Homogeneous()
        Dim day As Double = time / (60.0 * 60.0 * 24)
        Dim str As String = ""
        Dim ts2 As New TimeSpan(day * 10000000 * 60 * 60 * 24)
        runt = stopw.Elapsed.Add(ts).ToString()
        str = str + (dat + ts2) + vbCrLf
        str = str + String.Format("Pos(AU) = ({0:f3}, {1:f3}, {2:f3})", (pos.x(1) / AU), (pos.x(2) / AU), (pos.x(3) / AU)) + vbCrLf
        str = str + String.Format("time = {0}", time / 86400 / 365.24) + vbCrLf + vbCrLf
        str = str + vbCrLf + "running time= " + runt + vbCrLf + vbCrLf
        str = str + "LButton : YawAndPitch" + vbCrLf
        str = str + "RButton : RollAndAccel" + vbCrLf
        str = str + "MButton : Translate" + vbCrLf + vbCrLf
        str = str + "Programed by NAS6" + vbCrLf
        str = str + "printf(" + Microsoft.VisualBasic.ChrW(34) + "Hello World!" + Microsoft.VisualBasic.ChrW(92) + "n" + Microsoft.VisualBasic.ChrW(34) + ");" + vbCrLf
        Pad.TextBox.Text = str
    End Sub

    'XYZ軸表示線分設定
    Private Sub SetLine(ByRef p() As LineData, ByVal r As Double, ByVal mtr As Material)
        Dim i As Integer
        Dim j As Integer = 3
        Dim k As Integer
        Dim pv(j) As Vector
        For i = 0 To j
            pv(i) = New Vector(4, True)
        Next

        pv(0).x(1) = 0.0
        pv(0).x(2) = 0.0
        pv(0).x(3) = 0.0

        pv(1).x(1) = r
        pv(1).x(2) = 0.0
        pv(1).x(3) = 0.0

        pv(2).x(1) = 0.0
        pv(2).x(2) = r
        pv(2).x(3) = 0.0

        pv(3).x(1) = 0.0
        pv(3).x(2) = 0.0
        pv(3).x(3) = r

        k = 2
        ReDim p(k)
        For i = 0 To k
            p(i) = New LineData
            For j = 0 To 1
                p(i).v(j) = New Vector(4, True)
            Next
            p(i).mtr = mtr.Clone()
        Next

        p(0).v(0) = pv(0)
        p(0).v(1) = pv(1)
        p(0).vcol = Color.Red
        p(1).v(0) = pv(0)
        p(1).v(1) = pv(2)
        p(1).vcol = Color.Green
        p(2).v(0) = pv(0)
        p(2).v(1) = pv(3)
        p(2).vcol = Color.Blue
    End Sub

    '惑星軌道線分設定
    Private Sub SetLine(ByVal i As Integer, ByVal ii As Integer)
        Dim n As Integer = 48
        Dim p(n - 1) As LineData
        Dim mtr As New Material(1.0, 1.0)
        Dim j As Integer
        Dim x0 As Vector = planet(i).x0.Clone()
        '惑星１周を４８分割の線分設定
        For j = 1 To n - 1
            Dim dat1 As Date = dat.AddDays((360.0 * 360.0 / 360.25 / planet(i).m_nperday) * (CType(j, Double) / CType(n, Double)))
            Dim nday As Long = (dat1 - planet(i).m_dat0).TotalDays
            Dim xx As Vector = New Vector(2)
            Dim f As Double = planet(i).kepler(nday, xx)
            Dim x1 As Vector = New Vector(3)
            x1.x(0) = xx.x(0)
            x1.x(1) = xx.x(1)
            x1.x(2) = 0.0
            Dim xyz As Vector = New Vector(3)
            planet(i).ecliptic(x1.x(0), x1.x(1), xyz)
            If Double.IsNaN(xyz.x(0)) Or Double.IsNaN(xyz.x(1)) Or Double.IsNaN(xyz.x(2)) Then
                x1.x(0) = 0.0
                x1.x(1) = 0.0
                x1.x(2) = 0.0
            Else
                x1.x(0) = xyz.x(0)
                x1.x(1) = xyz.x(1)
                x1.x(2) = xyz.x(2)
            End If

            Dim h0 As Vector = x0.ToHomo()
            Dim h1 As Vector = x1.ToHomo()
            p(j - 1) = New LineData
            p(j - 1).v(0) = h0.Clone()
            p(j - 1).v(1) = h1.Clone()
            If ii <= i Then
                p(j - 1).vcol = Color.LightGreen
            Else
                p(j - 1).vcol = Color.Cyan
            End If
            p(j - 1).mtr = mtr.Clone()

            x0 = x1.Clone()
        Next
        Dim v0 As Vector = x0.ToHomo()
        Dim v1 As Vector = p(0).v(0).Clone()
        p(n - 1) = New LineData
        p(n - 1).v(0) = v0.Clone()
        p(n - 1).v(1) = v1.Clone()
        If ii <= i Then
            p(n - 1).vcol = Color.LightGreen
        Else
            p(n - 1).vcol = Color.Cyan
        End If
        p(n - 1).mtr = mtr.Clone()

        Dim LocalMat As New Matrix(4)
        Dim Loc As New Local
        LocalMat = LocalMat.UnitMat()
        Loc.lcl.Enqueue(LocalMat)
        Dim lcl As New Local
        Line(i) = New Line(Loc, p, CR, CB)
    End Sub

    'XYZ軸表示更新
    Private Sub SetAxis()
        Dim dtm As Double
        Dim LocalMat As New Matrix(4)
        LocalMat = r3d.Camera.Mat()
        LocalMat *= r3d.CameraMat
        LocalMat = LocalMat.InverseMat(dtm)
        LocalMat.x(1).x(0) = 0.0
        LocalMat.x(2).x(0) = 0.0
        LocalMat.x(3).x(0) = 0.0
        r3d.Line.buf(0).Local.lcl.buf(1) = LocalMat.Clone()
    End Sub

    'マウスボタンを押したときの直線表示
    Private Sub DragLine(ByRef SB As SpriteBatch)
        If MC.bd Then
            Dim p0 As New System.Windows.Point(GraphicsDevice.Viewport.Width / 2, GraphicsDevice.Viewport.Height / 2)
            r3d.DrawLine(SB, white, Color.Blue, GraphicsDevice.Viewport.Width, GraphicsDevice.Viewport.Height, GraphicsDevice.Viewport.Width / 2, GraphicsDevice.Viewport.Height / 2, p0, New System.Windows.Point(MC.bm.X, MC.bm.Y))
        End If
    End Sub

    'ケプラー方程式初期設定
    Private Sub InitKepler(ByVal sw As Boolean)
        bStart = True
        If sw Then
            Dim f As Form2 = New Form2()
            f.StartPosition = System.Windows.Forms.FormStartPosition.Manual
            f.Location = New System.Drawing.Point(MyBase.Window.ClientBounds.Right + 20, MyBase.Window.ClientBounds.Top)
            'モーダル開き、戻り値を受け取る
            Dim result As System.Windows.Forms.DialogResult = f.ShowDialog()
            If result = System.Windows.Forms.DialogResult.OK Then
                '値を受け取る
                dat = f.GetValue
            ElseIf result = System.Windows.Forms.DialogResult.No Then
                If sw = False Then
                    Return
                End If
            ElseIf result = System.Windows.Forms.DialogResult.Cancel Then
                If sw = False Then
                    Return
                End If
            End If
            f.Dispose()
        Else
            Dim day As Double = time / (60.0 * 60.0 * 24)
            Dim ts2 As New TimeSpan(day * 10000000 * 60 * 60 * 24)
            dat += ts2
        End If


        bfst = True


        Dim pn As Integer
        If asteroid Then
            pn = PlanetsNum
        Else
            pn = PlanetsANum
        End If
        ReDim mp(pn - 1)
        theta = 0.0
        Dim au As Double = 149597870700.0


        ReDim planet(pn - 1)

        '取得日時で惑星初期化
        PlanetInit(pn - 1, dat)




        dt = 60.0 * 60.0
        speed = dt
        time = -1.0


        Dim LocalMat As New Matrix(4)
        Dim Loc As New Local
        Dim Cam As New Local


        LocalMat = LocalMat.UnitMat()
        Cam.lcl.Enqueue(LocalMat)

        '惑星表示球体初期設定    
        Dim spr As New MyQueue(Of Sphere)
        ReDim Sphr(pn)
        Dim i As Integer
        For i = 0 To pn - 1
            Dim mtr As New Material(0.25, 0.8)
            Dim lbl As New Label
            Dim v As New Vector(4, True)
            v = v.ZeroVec()
            Dim vc As New Color
            Dim tc As New Color
            Select Case i
                Case 0
                    vc = New Color(192, 160, 0, 255)
                    tc = New Color(255, 192, 0, 255)
                    lbl = New Label("太陽(Sun)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    mtr = New Material(0.25, 0.8, True)
                    Exit Select
                Case 1
                    vc = New Color(160, 160, 160, 255)
                    tc = New Color(192, 192, 192, 255)
                    lbl = New Label("水星(Mercury)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 2
                    vc = New Color(0, 128, 160, 255)
                    tc = New Color(0, 160, 192, 255)
                    lbl = New Label("金星(Venus)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 3
                    vc = New Color(0, 160, 192, 255)
                    tc = New Color(0, 192, 255, 255)
                    lbl = New Label("地球(Earth)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 4
                    vc = New Color(160, 128, 0, 255)
                    tc = New Color(192, 160, 0, 255)
                    lbl = New Label("火星(Mars)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 5
                    vc = New Color(128, 160, 0, 255)
                    tc = New Color(160, 192, 0, 255)
                    lbl = New Label("木星(Jupiter)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 6
                    vc = New Color(160, 192, 0, 255)
                    tc = New Color(192, 255, 0, 255)
                    lbl = New Label("土星(Saturn)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 7
                    vc = New Color(0, 160, 128, 255)
                    tc = New Color(0, 192, 160, 255)
                    lbl = New Label("天王星(Uranus)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 8
                    vc = New Color(0, 192, 160, 255)
                    tc = New Color(0, 255, 192, 255)
                    lbl = New Label("海王星(Neptune)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 9
                    vc = New Color(128, 128, 128, 255)
                    tc = New Color(160, 160, 160, 255)
                    lbl = New Label("冥王星(Pluto)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 10
                    vc = New Color(64, 64, 64, 255)
                    tc = New Color(128, 128, 128, 255)
                    lbl = New Label("セレス(ceres)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 11
                    vc = New Color(64, 64, 64, 255)
                    tc = New Color(128, 128, 128, 255)
                    lbl = New Label("パラス(pallas)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 12
                    vc = New Color(64, 64, 64, 255)
                    tc = New Color(128, 128, 128, 255)
                    lbl = New Label("ジュノー(juno)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 13
                    vc = New Color(64, 64, 64, 255)
                    tc = New Color(128, 128, 128, 255)
                    lbl = New Label("ヴェスタ(vesta)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 14
                    vc = New Color(64, 64, 64, 255)
                    tc = New Color(128, 128, 128, 255)
                    lbl = New Label("キロン(chiron)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
            End Select
            Dim p As New SphereData(v, mp(i).r, vc, tc, mtr)

            Loc.lcl.Clear()
            LocalMat = LocalMat.UnitMat()
            LocalMat.x(1).x(0) = mp(i).x.x(0)
            LocalMat.x(2).x(0) = mp(i).x.x(1)
            LocalMat.x(3).x(0) = mp(i).x.x(2)
            Loc.lcl.Enqueue(LocalMat)


            Sphr(i) = New Sphere(Loc, p, CR, CB, lbl)
            'Sphr(i) = New Sphere(Loc, p)
            spr.Enqueue(Sphr(i))
        Next

        ReDim Line(pn - 1)
        Dim lin As New MyQueue(Of Line)

        'XYZ軸表示線分初期設定    
        Dim pl(0) As LineData
        Dim mtrl As New Material(1.0, 1.0)
        Dim lbll As New Label("Unit Vector", New System.Windows.Point(8, -24), Color.Cyan)
        InitParagraph(lbll.str)
        SetLine(pl, 0.25 * CR, mtrl)

        Loc.lcl.Clear()
        Loc.bcmr = True
        LocalMat = LocalMat.UnitMat()
        LocalMat.x(1).x(0) = -1.25 * CR
        LocalMat.x(2).x(0) = -1.25 * CR
        LocalMat.x(3).x(0) = 2.0 * CR
        Loc.lcl.Enqueue(LocalMat)
        LocalMat = LocalMat.UnitMat()
        Loc.lcl.Enqueue(LocalMat)

        Line(0) = New Line(Loc, pl, CR, CB, lbll, True)
        'Line(0) = New Line(Loc, p4)
        lin.Enqueue(Line(0))

        Dim pv As New Vector(4, True)
        pv = pv.ZeroVec()
        Dim ps As New SphereData(pv, 0.25 * CR, New Color(1, 1, 1, 255), Color.Black, mtrl)
        Sphr(pn) = New Sphere(Loc, ps, CR, CB)
        'Sphr(pn) = New Sphere(Loc, ps)
        spr.Enqueue(Sphr(pn))





        '惑星軌道線分初期設定
        For i = 1 To pn - 1
            SetLine(i, PlanetsANum)
            lin.Enqueue(Line(i))
        Next



        '照明初期設定
        Loc.lcl.Clear()
        LocalMat = LocalMat.UnitMat()
        Loc.lcl.Enqueue(LocalMat)
        Dim k(2) As Double
        k(0) = 0.0
        k(1) = 0.0
        k(2) = 1.0E-25
        Dim vd As New Vector(4, True)
        vd.x(0) = 1.0
        vd.x(1) = -1.0
        vd.x(2) = -1.0
        vd.x(3) = 1.0
        'Dim lgt As New Light(new Color(32, 32, 32, 255), Color.Black, Loc, k, new Color(192, 192, 192, 255), vd, True)
        Dim lgt As New Light(Color.Black, Color.White, Loc, k, Color.Black, vd, True)
        'Dim lgt As New Light(Color.Black, Color.White, Loc, k, Color.Black, vd, False)



        'レンダリング初期化
        r3d = New Render3D(Cam, lin, spr, CR, CB, lgt)
        'r3d = New Render3D(Cam, lin, spr, lgt)


        'マウスカメラ
        Dim m As New Matrix(4)
        m = m.UnitMat()
        m.x(3).x(0) = DZ
        r3d.CameraMat = m.Clone()
        MC.m = r3d.LookAtMat(0, True)
        r3d.CameraMat = MC.m.Clone()

        MC.Accel = 0.0


        stopw.Start()   'タイマースタート

        SetInfoKepler() '操作パッドに情報表示
        SetRate()       'Dash&Walkレート    

        bStart = False
    End Sub

    'ケプラー方程式メインループ
    Private Sub UpdateFrameKepler(ByRef SB As SpriteBatch)
        Dim au As Double = 149597870700.0

        If bfst Then
            bfst = False
            time = 0.0
            dt = 0.0
            time = 0.0
        End If

        SB.Draw(back, New Rectangle(0, 0, 360, 360), Color.White)   '画面クリア


        Dim pn As Integer
        If asteroid Then
            pn = PlanetsNum
        Else
            pn = PlanetsANum
        End If
        'メインループ
        Dim day As Double = time / (60.0 * 60.0 * 24)
        Dim tm As Double = 60.0 * 60.0 * 24.0 * (speed / (60.0 * 60.0))
        If Not dt = 0.0 Then
            time = time + tm
            day = time / (60.0 * 60.0 * 24)
            Dim ts2 As New TimeSpan(day * 10000000 * 60 * 60 * 24)
            Dim dat1 As DateTime = dat + ts2

            PlanetInit(pn - 1, dat1)    '新しい日時で惑星初期化
        End If

        Dim pmp() As MassPoint = mp

        '惑星表示球体更新
        Dim LocalMat As New Matrix(4)
        Dim i As Integer
        For i = 0 To pn - 1
            LocalMat = LocalMat.UnitMat()
            LocalMat.x(1).x(0) = pmp(i).x.x(0)
            LocalMat.x(2).x(0) = pmp(i).x.x(1)
            LocalMat.x(3).x(0) = pmp(i).x.x(2)
            r3d.Sphr.buf(i).Local.lcl.buf(0) = LocalMat.Clone()
        Next

        MC.UpdateFrame()    'マウスカメラ

        '視点選択処理
        r3d.CameraMat = MC.m.Clone()
        If Pad.ListBox1.SelectedIndex <= pn Then
            If 0 < Pad.ListBox1.SelectedIndex Then
                MC.m = r3d.LookAtMat(Pad.ListBox1.SelectedIndex - 1, True)
            End If
        End If
        r3d.CameraMat = MC.m.Clone()

        SetAxis()   'XYZ軸表示更新


        'レンダリング
        'r3d.Render(SB, white, 360, 360, 180, 180, False)
        r3d.Render(SB, white, 360, 360, 180, 180, True)

        'マウスボタン操作の線分
        DragLine(SB)


        '操作パッドに情報更新
        SetInfoKepler()
        'Dash&Walk更新
        SetRate()
    End Sub


    '惑星初期化
    Private Sub PlanetInit(ByVal z As Integer, ByVal dat As DateTime)
        Dim i As Integer
        Dim j As Integer
        If bfst Then
            'データファイル読み込み
            Dim FileName As String = "Content\PlanetData.txt"
            Dim Reader As IO.StreamReader
            Dim Encode As System.Text.Encoding
            Encode = System.Text.Encoding.GetEncoding("Shift-JIS")

            Reader = New IO.StreamReader(FileName, Encode)

            i = 0
            While Not Reader.EndOfStream
                Dim str As String = Reader.ReadLine()

                Dim tkn() As String = str.Split(",")
                For j = 0 To tkn.Length - 1
                    Dim removeChars As Char() = New Char() {vbTab, " "}
                    For Each c As Char In removeChars
                        tkn(j) = tkn(j).Replace(c.ToString(), "")
                    Next
                Next

                If Not tkn(0)(0).ToString() = "#" Then
                    Dim PlanetName As String = tkn(0)
                    Dim PlanetNo As Integer = Integer.Parse(tkn(1))
                    Dim EpochYY As Integer = Integer.Parse(tkn(2))
                    Dim EpochMM As Integer = Integer.Parse(tkn(3))
                    Dim EpochDD As Integer = Integer.Parse(tkn(4))
                    Dim Epochh As Integer = Integer.Parse(tkn(5))
                    Dim Epochm As Integer = Integer.Parse(tkn(6))
                    Dim Epochs As Integer = Integer.Parse(tkn(7))
                    Dim a As Double = Double.Parse(tkn(8))
                    Dim e As Double = Double.Parse(tkn(9))
                    Dim m0 As Double = Double.Parse(tkn(10))
                    Dim npd As Double = Double.Parse(tkn(11))
                    Dim ra As Double = Double.Parse(tkn(12))
                    Dim rb As Double = Double.Parse(tkn(13))
                    Dim p As Double = Double.Parse(tkn(14))
                    Dim ss As Double = Double.Parse(tkn(15))
                    Dim ii As Double = Double.Parse(tkn(16))
                    Dim ww As Double = Double.Parse(tkn(17))
                    Dim m As Double = Double.Parse(tkn(18))
                    Dim r As Double = Double.Parse(tkn(19))
                    Dim mv As Double = Double.Parse(tkn(20))

                    Dim dat0 As New DateTime(EpochYY, EpochMM, EpochDD, Epochh, Epochm, Epochs)
                    Dim ddat As Double = (dat - dat0).TotalDays

                    '惑星初期化
                    planet(i) = New Planet(PlanetNo, ddat, dat0, a, e, m0, npd, ra, rb, p, ss, ii, ww, m, r, mv, rk.CNST_C)
                    '質点初期化
                    mp(i) = New MassPoint(planet(i).x0, planet(i).v0, m, r)

                    If i = z Then
                        Exit While
                    End If
                    i = i + 1
                End If
            End While
            Reader.Close()
        Else
            For i = 0 To z
                Dim dat0 As DateTime = planet(i).m_dat0
                Dim nday As Double = (dat - dat0).TotalDays

                Dim au As Double = 149597870700.0
                Dim dr As Double = 0.017453292519943
                Dim ve As Double = 29780.0

                Dim xx As Vector = New Vector(2)
                Dim f As Double = planet(i).kepler(nday, xx)
                planet(i).x0 = New Vector(3)
                planet(i).x0.x(0) = xx.x(0)
                planet(i).x0.x(1) = xx.x(1)
                planet(i).x0.x(2) = 0.0


                Dim xyz As Vector = New Vector(3)
                planet(i).ecliptic(planet(i).x0.x(0), planet(i).x0.x(1), xyz)
                If Double.IsNaN(xyz.x(0)) Or Double.IsNaN(xyz.x(1)) Or Double.IsNaN(xyz.x(2)) Then
                    planet(i).x0.x(0) = 0.0
                    planet(i).x0.x(1) = 0.0
                    planet(i).x0.x(2) = 0.0
                Else
                    planet(i).x0.x(0) = xyz.x(0)
                    planet(i).x0.x(1) = xyz.x(1)
                    planet(i).x0.x(2) = xyz.x(2)
                End If

                planet(i).v0 = New Vector(3)
                If Not BK Then
                    Dim xyz2 As Vector = New Vector(3)

                    'ケプラー方程式から軌道速度を求める
                    Dim xxx As Vector = New Vector(2)
                    planet(i).kepler(nday + (1.0 / (24.0 * 4.0) * planet(i).m_t), xxx)
                    Dim vv As Vector = xxx - xx
                    '速度微調整
                    planet(i).v0.x(0) = (vv.x(0) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0) * planet(i).m_t) / planet(i).CNST_C) * planet(i).m_mv
                    planet(i).v0.x(1) = (vv.x(1) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0) * planet(i).m_t) / planet(i).CNST_C) * planet(i).m_mv
                    planet(i).v0.x(2) = 0.0

                    '速度微調整
                    'If planet(i).m_pno = 1 Then '水星
                    'Dim h As Double = (planet(i).x0.x(0) / au - 0.30896923101164997) * (-0.00223 / (0.46326146586797912 + 0.30896923101164997)) + 4.03027
                    'planet(i).v0.x(0) = vv.x(0) / (60.0 * 60.0 * 24.0 / (24.0 * h)) / planet(i).CNST_C
                    'planet(i).v0.x(1) = vv.x(1) / (60.0 * 60.0 * 24.0 / (24.0 * h)) / planet(i).CNST_C
                    'ElseIf planet(i).m_pno = 2 Then '金星
                    'planet(i).v0.x(0) = vv.x(0) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0075)) / planet(i).CNST_C
                    'planet(i).v0.x(1) = vv.x(1) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0075)) / planet(i).CNST_C
                    'ElseIf planet(i).m_pno = 4 Then '火星
                    'planet(i).v0.x(0) = vv.x(0) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0025)) / planet(i).CNST_C
                    'planet(i).v0.x(1) = vv.x(1) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0025)) / planet(i).CNST_C
                    'Else 'その他
                    'planet(i).v0.x(0) = vv.x(0) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0)) / planet(i).CNST_C
                    'planet(i).v0.x(1) = vv.x(1) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0)) / planet(i).CNST_C
                    'End If
                    'planet(i).v0.x(2) = 0.0

                    '面積速度一定から軌道速度を求める
                    'm_t = 1.0 / (m_nperday * dr * 365.2425 / (2.0 * Math.PI))
                    'Dim vst As Double = ((1.0 / 2.0) * (Math.Sqrt(m_ra * m_rb)) * (m_ra + m_rb)) / m_t
                    'Dim vr As Double = (vst / (x0.Abs() / au)) * ve / CNST_C
                    'v0.x(0) = fabs(vr * Math.Sin(f))
                    'v0.x(1) = fabs(vr * Math.Cos(f))
                    'sgnv(x0.x(0), x0.x(1), v0.x(0), v0.x(1))

                    planet(i).ecliptic(planet(i).v0.x(0), planet(i).v0.x(1), xyz2)
                    If Double.IsNaN(xyz2.x(0)) Or Double.IsNaN(xyz2.x(1)) Or Double.IsNaN(xyz2.x(2)) Then
                        planet(i).v0.x(0) = 0.0
                        planet(i).v0.x(1) = 0.0
                        planet(i).v0.x(2) = 0.0
                    Else
                        planet(i).v0.x(0) = xyz2.x(0)
                        planet(i).v0.x(1) = xyz2.x(1)
                        planet(i).v0.x(2) = xyz2.x(2)
                    End If
                End If

                mp(i) = New MassPoint(planet(i).x0, planet(i).v0, planet(i).m_m, planet(i).m_r)
            Next
        End If
    End Sub

    '↓ここから相対論
    '操作パッドに情報表示
    Private Sub SetInfo()
        Dim mat As Matrix = r3d.Camera.Mat()
        mat *= r3d.CameraMat
        mat = mat.Homogeneous()
        Dim pos As Vector = mat.Pos()
        pos = pos.Homogeneous()
        Dim day As Double = time / (60.0 * 60.0 * 24)
        Dim str As String = ""
        Dim ts2 As New TimeSpan(day * 10000000 * 60 * 60 * 24)
        runt = stopw.Elapsed.Add(ts).ToString()
        Dim nt As Double = ntime
        If ntime < 3.0 Then
            nt = 3.0
        End If
        str = str + (dat + ts2) + vbCrLf
        str = str + String.Format("Pos(AU) = ({0:f3}, {1:f3}, {2:f3})", (pos.x(1) / AU), (pos.x(2) / AU), (pos.x(3) / AU)) + vbCrLf
        str = str + String.Format("time = {0}", time / 86400 / 365.24) + vbCrLf + vbCrLf
        str = str + String.Format("MercuryTh = {0}", -theta) + vbCrLf
        str = str + String.Format("MercuryTh2 = {0}", -theta2) + vbCrLf
        str = str + String.Format("MercuryThAve = {0}", -theta2 / (nt - 2.0)) + vbCrLf
        str = str + String.Format("MercuryLaps = {0}", nt - 2.0) + vbCrLf
        str = str + vbCrLf + "running time= " + runt + vbCrLf + vbCrLf
        str = str + "LButton : YawAndPitch" + vbCrLf
        str = str + "RButton : RollAndAccel" + vbCrLf
        str = str + "MButton : Translate" + vbCrLf + vbCrLf
        str = str + "Programed by NAS6" + vbCrLf
        str = str + "printf(" + Microsoft.VisualBasic.ChrW(34) + "Hello World!" + Microsoft.VisualBasic.ChrW(92) + "n" + Microsoft.VisualBasic.ChrW(34) + ");" + vbCrLf
        Pad.TextBox.Text = str
    End Sub

    '惑星調整（コード中使用していない）
    Private Sub AdjustPlanet(ByRef pmp() As MassPoint)
        Dim day As Double = time / (60.0 * 60.0 * 24)
        Dim str As String = ""
        Dim ts2 As New TimeSpan(day * 10000000 * 60 * 60 * 24)
        Dim dat1 As Date = dat + ts2
        Dim i As Integer = 1
        Dim nday As Long = (dat1 - planet(i).m_dat0).TotalDays
        Dim xx As Vector = New Vector(2)
        Dim f As Double = planet(i).kepler(nday, xx)
        Dim x As Vector = New Vector(3)
        x.x(0) = xx.x(0)
        x.x(1) = xx.x(1)
        x.x(2) = 0.0
        Dim xyz As Vector = New Vector(3)
        planet(i).ecliptic(x.x(0), x.x(1), xyz)
        If Double.IsNaN(xyz.x(0)) Or Double.IsNaN(xyz.x(1)) Or Double.IsNaN(xyz.x(2)) Then
            x.x(0) = 0.0
            x.x(1) = 0.0
            x.x(2) = 0.0
        Else
            x.x(0) = xyz.x(0)
            x.x(1) = xyz.x(1)
            x.x(2) = xyz.x(2)
        End If
        Dim dx As Vector = pmp(i).x - x
        Dim d As Double = dx.Abs()
        Dim a As Integer

        '水星の誤差が半径の１％を超えたら再初期化
        If planet(i).m_a * AU / 100.0 < d Then
            Dim pn As Integer
            If asteroid Then
                pn = PlanetsNum
            Else
                pn = PlanetsANum
            End If

            PlanetInit(pn - 1, dat1)
            rk.Init(mp, dt)
            Dim pmpe(pn - 1) As MassPoint
            For a = 0 To pn - 1
                pmpe(a) = New MassPoint(3)
                pmpe(a) = rk.mp(a).Clone()
            Next
            el.Init(pmpe, dt)
        End If
    End Sub

    'SolarSystem水星摂動574秒/415周=3.8420348058902275769745649263722e-4秒=6.7056157339004564926372155287818e-6rad
    '相対論初期化
    Private Sub InitRelative(ByVal sw As Boolean)
        bStart = True
        If sw Then
            Dim f As Form2 = New Form2()
            f.StartPosition = System.Windows.Forms.FormStartPosition.Manual
            f.Location = New System.Drawing.Point(MyBase.Window.ClientBounds.Right + 20, MyBase.Window.ClientBounds.Top)
            'モーダル開き、戻り値を受け取る
            Dim result As System.Windows.Forms.DialogResult = f.ShowDialog()
            If result = System.Windows.Forms.DialogResult.OK Then
                '値を受け取る
                dat = f.GetValue
            ElseIf result = System.Windows.Forms.DialogResult.No Then
                If sw = False Then
                    Return
                End If
            ElseIf result = System.Windows.Forms.DialogResult.Cancel Then
                If sw = False Then
                    Return
                End If
            End If
            f.Dispose()
        Else
            Dim day As Double = time / (60.0 * 60.0 * 24)
            Dim ts2 As New TimeSpan(day * 10000000 * 60 * 60 * 24)
            dat += ts2
        End If

        bfst = True

        Dim pn As Integer
        If asteroid Then
            pn = PlanetsNum
        Else
            pn = PlanetsANum
        End If
        ReDim mp(pn - 1)
        theta = 0.0
        Dim au As Double = 149597870700.0


        ReDim planet(pn - 1)

        '取得日時で惑星初期化
        PlanetInit(pn - 1, dat)




        dt = 60.0 * 60.0
        speed = dt
        time = -1.0
        xxx = mp(1).x.Clone()

        ntime = 0.0
        hialt = mp(1).v.x(0)
        hialt2 = mp(1).v.x(1)
        rgt = True



        rgt = True
        rgt2 = True
        rgt3 = True
        rgt4 = True
        hialt2 = (mp(1).x - mp(0).x).Abs()
        xxx = mp(1).x.Clone()
        ntime = 1.0
        theta = 0.0
        theta2 = 0.0
        theta3 = 0.0
        hialttmp = hialt2
        thetatmp = 0.0

        rk.Init(mp, dt)

        Dim pmp(pn - 1) As MassPoint
        Dim a As Integer
        For a = 0 To pn - 1
            pmp(a) = New MassPoint(3)
            pmp(a) = rk.mp(a).Clone()
        Next
        dt = 60.0 * 60.0 * 24.0
        el.Init(pmp, dt)




        Dim LocalMat As New Matrix(4)
        Dim Loc As New Local
        Dim Cam As New Local


        LocalMat = LocalMat.UnitMat()
        Cam.lcl.Enqueue(LocalMat)


        Dim spr As New MyQueue(Of Sphere)
        ReDim Sphr(pn)
        Dim i As Integer
        '惑星表示球体初期設定    
        For i = 0 To pn - 1
            Dim mtr As New Material(0.25, 0.8)
            Dim lbl As New Label
            Dim v As New Vector(4, True)
            v = v.ZeroVec()
            Dim vc As New Color
            Dim tc As New Color
            Select Case i
                Case 0
                    vc = New Color(192, 160, 0, 255)
                    tc = New Color(255, 192, 0, 255)
                    lbl = New Label("太陽(Sun)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    mtr = New Material(0.25, 0.8, True)
                    Exit Select
                Case 1
                    vc = New Color(160, 160, 160, 255)
                    tc = New Color(192, 192, 192, 255)
                    lbl = New Label("水星(Mercury)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 2
                    vc = New Color(0, 128, 160, 255)
                    tc = New Color(0, 160, 192, 255)
                    lbl = New Label("金星(Venus)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 3
                    vc = New Color(0, 160, 192, 255)
                    tc = New Color(0, 192, 255, 255)
                    lbl = New Label("地球(Earth)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 4
                    vc = New Color(160, 128, 0, 255)
                    tc = New Color(192, 160, 0, 255)
                    lbl = New Label("火星(Mars)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 5
                    vc = New Color(128, 160, 0, 255)
                    tc = New Color(160, 192, 0, 255)
                    lbl = New Label("木星(Jupiter)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 6
                    vc = New Color(160, 192, 0, 255)
                    tc = New Color(192, 255, 0, 255)
                    lbl = New Label("土星(Saturn)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 7
                    vc = New Color(0, 160, 128, 255)
                    tc = New Color(0, 192, 160, 255)
                    lbl = New Label("天王星(Uranus)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 8
                    vc = New Color(0, 192, 160, 255)
                    tc = New Color(0, 255, 192, 255)
                    lbl = New Label("海王星(Neptune)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 9
                    vc = New Color(128, 128, 128, 255)
                    tc = New Color(160, 160, 160, 255)
                    lbl = New Label("冥王星(Pluto)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 10
                    vc = New Color(64, 64, 64, 255)
                    tc = New Color(128, 128, 128, 255)
                    lbl = New Label("セレス(ceres)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 11
                    vc = New Color(64, 64, 64, 255)
                    tc = New Color(128, 128, 128, 255)
                    lbl = New Label("パラス(pallas)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 12
                    vc = New Color(64, 64, 64, 255)
                    tc = New Color(128, 128, 128, 255)
                    lbl = New Label("ジュノー(juno)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 13
                    vc = New Color(64, 64, 64, 255)
                    tc = New Color(128, 128, 128, 255)
                    lbl = New Label("ヴェスタ(vesta)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
                Case 14
                    vc = New Color(64, 64, 64, 255)
                    tc = New Color(128, 128, 128, 255)
                    lbl = New Label("キロン(chiron)", New System.Windows.Point(8, 0), Color.Green)
                    InitParagraph(lbl.str)
                    Exit Select
            End Select
            Dim p As New SphereData(v, mp(i).r, vc, tc, mtr)

            Loc.lcl.Clear()
            LocalMat = LocalMat.UnitMat()
            LocalMat.x(1).x(0) = mp(i).x.x(0)
            LocalMat.x(2).x(0) = mp(i).x.x(1)
            LocalMat.x(3).x(0) = mp(i).x.x(2)
            Loc.lcl.Enqueue(LocalMat)


            Sphr(i) = New Sphere(Loc, p, CR, CB, lbl)
            'Sphr(i) = New Sphere(Loc, p)
            spr.Enqueue(Sphr(i))
        Next

        ReDim Line(pn - 1)
        Dim lin As New MyQueue(Of Line)


        'XYZ軸表示線分初期設定    
        Dim pl(0) As LineData
        Dim mtrl As New Material(1.0, 1.0)
        Dim lbll As New Label("Unit Vector", New System.Windows.Point(8, -24), Color.Cyan)
        InitParagraph(lbll.str)
        SetLine(pl, 0.25 * CR, mtrl)

        Loc.lcl.Clear()
        Loc.bcmr = True
        LocalMat = LocalMat.UnitMat()
        LocalMat.x(1).x(0) = -1.25 * CR
        LocalMat.x(2).x(0) = -1.25 * CR
        LocalMat.x(3).x(0) = 2.0 * CR
        Loc.lcl.Enqueue(LocalMat)
        LocalMat = LocalMat.UnitMat()
        Loc.lcl.Enqueue(LocalMat)

        Line(0) = New Line(Loc, pl, CR, CB, lbll, True)
        'Line(0) = New Line(Loc, p4)
        lin.Enqueue(Line(0))


        Dim pv As New Vector(4, True)
        pv = pv.ZeroVec()
        Dim ps As New SphereData(pv, 0.25 * CR, New Color(1, 1, 1, 255), Color.Black, mtrl)
        Sphr(pn) = New Sphere(Loc, ps, CR, CB)
        'Sphr(pn) = New Sphere(Loc, ps)
        spr.Enqueue(Sphr(pn))



        '惑星軌道線分初期設定
        For i = 1 To pn - 1
            SetLine(i, PlanetsANum)
            lin.Enqueue(Line(i))
        Next




        '照明初期設定
        Loc.lcl.Clear()
        LocalMat = LocalMat.UnitMat()
        Loc.lcl.Enqueue(LocalMat)
        Dim k(2) As Double
        k(0) = 0.0
        k(1) = 0.0
        k(2) = 1.0E-25
        Dim vd As New Vector(4, True)
        vd.x(0) = 1.0
        vd.x(1) = -1.0
        vd.x(2) = -1.0
        vd.x(3) = 1.0
        'Dim lgt As New Light(new Color(32, 32, 32, 255), Color.Black, Loc, k, new Color(192, 192, 192, 255), vd, True)
        Dim lgt As New Light(Color.Black, Color.White, Loc, k, Color.Black, vd, True)
        'Dim lgt As New Light(Color.Black, Color.White, Loc, k, Color.Black, vd, False)




        'レンダリング初期化
        r3d = New Render3D(Cam, lin, spr, CR, CB, lgt)
        'r3d = New Render3D(Cam, lin, spr, lgt)



        'マウスカメラ
        Dim m As New Matrix(4)
        m = m.UnitMat()
        m.x(3).x(0) = DZ
        r3d.CameraMat = m.Clone()
        MC.m = r3d.LookAtMat(0, True)
        r3d.CameraMat = MC.m.Clone()

        MC.Accel = 0.0




        stopw.Start()   'タイマースタート

        SetInfoKepler() '操作パッドに情報表示
        SetRate()       'Dash&Walkレート    

        bStart = False
    End Sub

    '相対論メインループ
    Private Sub UpdateFrameRelative(ByRef SB As SpriteBatch)
        Dim au As Double = 149597870700.0

        If bfst Then
            bfst = False
            time = 0.0

            dt = 0.0
            time = 0.0

        End If

        SB.Draw(back, New Rectangle(0, 0, 360, 360), Color.White)


        Dim pmp() As MassPoint = rk.mp

        'メインループ

        Dim adt As Double = Math.Abs(dt)

        '消去()
        'gPic.FillRectangle(Brushes.Black, 0, 0, 360, 360)
        Dim day As Double = time / (60.0 * 60.0 * 24)
        Dim alt As Double = (pmp(1).x - pmp(0).x).Abs() ' - 6356752.0
        Dim dtt As Double = (Math.PI / 180.0 * 0.0328) * adt
        Dim v1 As Vector

        Dim i As Integer
        Dim t As Double
        Dim tm As Double = Math.Abs(60.0 * 60.0 * 24.0 * (speed / (60.0 * 60.0)))

        Dim nn As Integer = 1
        Dim dd As Double = (planet(nn).m_rb - planet(nn).m_ra) / 2.0
        Dim pn As Integer
        If asteroid Then
            pn = PlanetsNum
        Else
            pn = PlanetsANum
        End If

        If Not dt = 0.0 Then
            For t = dt To tm Step adt
                time = time + dt
                day = time / (60.0 * 60.0 * 24)



                Dim vvv As Vector = pmp(nn).x


                '質点アップデート
                'el.UpdateFrame()
                rk.UpdateFrame()


                '太陽原点補正
                For i = 1 To pn - 1
                    pmp(i).x -= pmp(0).x
                Next
                Dim zero As New Vector(3, False)
                zero = zero.ZeroVec()
                pmp(0).x = zero


                v1 = pmp(nn).x - pmp(0).x
                alt = v1.Abs()

                Dim bbb As Boolean = False
                Dim ccc As Boolean = False

                '近日点判定
                Dim th2 As Double = (v1.UnitVec(1) * -1.0).Theta(v1)
                If hialt2 <= alt And rgt = True Then
                    If alt <= (planet(nn).m_a + dd) * au Then
                        ccc = True
                        rgt = False
                        If rgt2 = True Then
                            rgt2 = False
                            bbb = True
                        End If
                    End If
                ElseIf alt < hialt2 And rgt = False Then
                    rgt = True
                    If (planet(nn).m_a - dd) * au < alt And rgt2 = False Then
                        rgt2 = True
                        rgt4 = True
                        hialttmp = alt
                        thetatmp = theta
                    End If
                End If

                If ccc Then
                    If alt < hialttmp Then
                        hialttmp = alt
                        thetatmp = th2
                    End If
                End If

                If rgt4 = True And rgt2 = False And (th2 < theta - 0.5 Or theta + 0.5 < th2) Then
                    ntime = ntime + 1.0
                    rgt4 = False
                    hialt = hialttmp
                    If ntime < 3.0 Then
                        GoTo LABEL00
                    ElseIf ntime = 3.0 Then
                        verror = day
                        theta3 = thetatmp
                        theta2 = 0.0
                        thetatmp = 0.0
                    End If
                    theta = thetatmp - theta2 - theta3
                    theta2 = thetatmp - theta3

                End If
LABEL00:

                hialt2 = alt
                If 6.0 = ntime Then
                    alt = (day - verror) / 3.0
                    theta = theta
                End If

            Next
            'AdjustPlanet(pmp) 'コメントアウトで純粋に相対論
        End If


        '惑星表示球体更新
        Dim LocalMat As New Matrix(4)
        For i = 0 To pn - 1
            LocalMat = LocalMat.UnitMat()
            LocalMat.x(1).x(0) = pmp(i).x.x(0)
            LocalMat.x(2).x(0) = pmp(i).x.x(1)
            LocalMat.x(3).x(0) = pmp(i).x.x(2)
            r3d.Sphr.buf(i).Local.lcl.buf(0) = LocalMat.Clone()
        Next


        MC.UpdateFrame()    'マウスカメラ

        '視点選択処理
        r3d.CameraMat = MC.m.Clone()
        If Pad.ListBox1.SelectedIndex <= pn Then
            If 0 < Pad.ListBox1.SelectedIndex Then
                MC.m = r3d.LookAtMat(Pad.ListBox1.SelectedIndex - 1, True)
            End If
        End If
        r3d.CameraMat = MC.m.Clone()

        SetAxis()   'XYZ軸表示更新


        'レンダリング
        'r3d.Render(SB, white, 360, 360, 180, 180, False)
        r3d.Render(SB, white, 360, 360, 180, 180, True)

        'マウスボタン操作の線分
        DragLine(SB)


        '操作パッドに情報更新
        SetInfoKepler()
        'Dash&Walk更新
        SetRate()
    End Sub

End Class
