﻿'Programed by NAS6


Imports System.Windows

Public Class LineData
    Implements ICloneable

    Public v(1) As Vector               '線分座標
    Public vcol As Color                '頂点カラー
    Public mtr As Material              '物性

    Public Sub New()
        Dim IntWK As Integer
        For IntWK = 0 To 1
            v(IntWK) = New Vector(4, True)
        Next
        vcol = Color.White
        mtr = New Material
    End Sub

    Public Sub New(ByVal pv() As Vector, ByVal pvc As Color, ByVal pm As Material)
        Dim IntWK As Integer
        For IntWK = 0 To 1
            v(IntWK) = pv(IntWK).Clone()
        Next
        vcol = pvc
        mtr = pm.Clone()
    End Sub

    Public Function Clone() As Object Implements ICloneable.Clone
        Dim ret As New LineData
        Dim i As Integer
        For i = 0 To 1
            ret.v(i) = Me.v(i).Clone()
        Next
        ret.vcol = Me.vcol
        ret.mtr = Me.mtr.Clone()
        Return ret
    End Function
End Class

Public Class Line
    Implements IComparable
    Implements ICloneable

    Public Local As New Local       'ローカル行列群
    Public v() As LineData          '線分  
    Public Range As Double = 1.0    '範囲
    Public Base As Double = 2.0     '基数
    Public Label As New Label       'ラベル
    Public Opt As Boolean = False   '錯視対策

    Public Function Clone() As Object Implements ICloneable.Clone
        Dim i As Integer
        Dim vv(v.Length - 1) As LineData
        For i = 0 To v.Length - 1
            vv(i) = v(i).Clone()
        Next
        Dim ret As New Line(Me.Local.Clone(), vv, Me.Range, Me.Base, Me.Label.Clone(), Me.Opt)
        Return ret
    End Function

    Public Function CompareTo(obj As Object) As Integer Implements IComparable.CompareTo
        CompareTo = 0
        Dim lh As Line = Me
        Dim rh As Line = obj
        If Not (lh.Base = rh.Base) Then
            CompareTo = CompareTo Or 1
        End If
    End Function

    Public Overrides Function Equals(obj As Object) As Boolean
        Dim ret As Integer = CompareTo(obj)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Shared Operator =(ByVal lh As Line, ByVal rh As Line) As Boolean
        Dim ret As Integer = lh.CompareTo(rh)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Operator

    Public Shared Operator <>(ByVal lh As Line, ByVal rh As Line) As Boolean
        Return (Not lh = rh)
    End Operator

    Public Sub New(ByVal lcl As Local, ByVal pv() As LineData)
        Local = lcl.Clone()
        Dim i As Integer
        Dim nn As Integer = pv.Length - 1
        ReDim v(nn)
        For i = 0 To nn
            v(i) = pv(i).Clone()
        Next
    End Sub

    Public Sub New(ByVal lcl As Local, ByVal pv() As LineData, ByVal rg As Double, ByVal bs As Double)
        Local = lcl.Clone()
        Dim i As Integer
        Dim nn As Integer = pv.Length - 1
        ReDim v(nn)
        For i = 0 To nn
            v(i) = pv(i).Clone()
        Next
        Range = rg
        Base = bs
    End Sub


    Public Sub New(ByVal lcl As Local, ByVal pv() As LineData, ByVal lbl As Label)
        Local = lcl.Clone()
        Label = lbl.Clone()
        Dim i As Integer
        Dim nn As Integer = pv.Length - 1
        ReDim v(nn)
        For i = 0 To nn
            v(i) = pv(i).Clone()
        Next
    End Sub

    Public Sub New(ByVal lcl As Local, ByVal pv() As LineData, ByVal rg As Double, ByVal bs As Double, ByVal lbl As Label)
        Local = lcl.Clone()
        Label = lbl.Clone()
        Dim i As Integer
        Dim nn As Integer = pv.Length - 1
        ReDim v(nn)
        For i = 0 To nn
            v(i) = pv(i).Clone()
        Next
        Range = rg
        Base = bs
    End Sub


    Public Sub New(ByVal lcl As Local, ByVal pv() As LineData, ByVal po As Boolean)
        Local = lcl.Clone()
        Dim i As Integer
        Dim nn As Integer = pv.Length - 1
        ReDim v(nn)
        For i = 0 To nn
            v(i) = pv(i).Clone()
        Next
        Opt = po
    End Sub

    Public Sub New(ByVal lcl As Local, ByVal pv() As LineData, ByVal rg As Double, ByVal bs As Double, ByVal po As Boolean)
        Local = lcl.Clone()
        Dim i As Integer
        Dim nn As Integer = pv.Length - 1
        ReDim v(nn)
        For i = 0 To nn
            v(i) = pv(i).Clone()
        Next
        Range = rg
        Base = bs
        Opt = po
    End Sub


    Public Sub New(ByVal lcl As Local, ByVal pv() As LineData, ByVal lbl As Label, ByVal po As Boolean)
        Local = lcl.Clone()
        Label = lbl.Clone()
        Dim i As Integer
        Dim nn As Integer = pv.Length - 1
        ReDim v(nn)
        For i = 0 To nn
            v(i) = pv(i).Clone()
        Next
        Opt = po
    End Sub

    Public Sub New(ByVal lcl As Local, ByVal pv() As LineData, ByVal rg As Double, ByVal bs As Double, ByVal lbl As Label, ByVal po As Boolean)
        Local = lcl.Clone()
        Label = lbl.Clone()
        Dim i As Integer
        Dim nn As Integer = pv.Length - 1
        ReDim v(nn)
        For i = 0 To nn
            v(i) = pv(i).Clone()
        Next
        Range = rg
        Base = bs
        Opt = po
    End Sub


End Class
