﻿'Programed by NAS6

'対数クォータニオン
Public Class LnQuaternion
    Implements IComparable
    Implements ICloneable

    Public q As New Vector(3)


    Public Function Clone() As Object Implements ICloneable.Clone
        Dim ret As New LnQuaternion
        ret.q = Me.q.Clone()
        Return ret
    End Function

    Public Function CompareTo(obj As Object) As Integer Implements IComparable.CompareTo
        CompareTo = 0
        Dim lh As LnQuaternion = Me
        Dim rh As LnQuaternion = obj
        Dim i As Integer
        For i = 0 To 2
            If Not lh.q.x(i) = rh.q.x(i) Then
                CompareTo = CompareTo Or (1 << i)
            End If
        Next
    End Function

    Public Overrides Function Equals(obj As Object) As Boolean
        Dim ret As Integer = CompareTo(obj)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Shared Operator =(ByVal lh As LnQuaternion, ByVal rh As LnQuaternion) As Boolean
        Dim ret As Integer = lh.CompareTo(rh)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Operator

    Public Shared Operator <>(ByVal lh As LnQuaternion, ByVal rh As LnQuaternion) As Boolean
        Return (Not lh = rh)
    End Operator


    Public Sub New()
        Dim i As Integer
        For i = 0 To 2
            q.x(i) = 0.0
        Next
    End Sub

    Public Sub New(ByVal x As Double, ByVal y As Double, ByVal z As Double)
        q.x(0) = x
        q.x(1) = y
        q.x(2) = z
    End Sub

    Public Sub New(ByVal v As Vector)
        q.x(0) = v.x(0)
        q.x(1) = v.x(1)
        q.x(2) = v.x(2)
    End Sub

    Public Shared Operator *(ByVal lh As LnQuaternion, ByVal rh As Double) As LnQuaternion
        Dim IntWK As Integer = 0
        Dim QuatWK As New LnQuaternion
        For IntWK = 0 To 2
            QuatWK.q.x(IntWK) = lh.q.x(IntWK) * rh
        Next
        Return QuatWK
    End Operator

    Public Shared Operator /(ByVal lh As LnQuaternion, ByVal rh As Double) As LnQuaternion
        Dim IntWK As Integer = 0
        Dim QuatWK As New LnQuaternion
        If rh = 0.0 Then
            Return QuatWK
        End If
        For IntWK = 0 To 2
            QuatWK.q.x(IntWK) = lh.q.x(IntWK) / rh
        Next
        Return QuatWK
    End Operator

    Public Shared Operator +(ByVal lh As LnQuaternion, ByVal rh As LnQuaternion) As LnQuaternion
        Dim IntWK As Integer = 0
        Dim QuatWK As New LnQuaternion
        For IntWK = 0 To 2
            QuatWK.q.x(IntWK) = lh.q.x(IntWK) + rh.q.x(IntWK)
        Next
        Return QuatWK
    End Operator

    Public Shared Operator -(ByVal lh As LnQuaternion, ByVal rh As LnQuaternion) As LnQuaternion
        Dim IntWK As Integer = 0
        Dim QuatWK As New LnQuaternion
        For IntWK = 0 To 2
            QuatWK.q.x(IntWK) = lh.q.x(IntWK) - rh.q.x(IntWK)
        Next
        Return QuatWK
    End Operator


    '絶対値2乗
    Public Function SquareAbs() As Double
        Dim IntWK As Integer = 0
        Dim DblWK As Double = 0.0
        Dim QuatWK As LnQuaternion = Me.Clone()
        For IntWK = 0 To 2
            DblWK += QuatWK.q.x(IntWK) * QuatWK.q.x(IntWK)
        Next
        Return DblWK
    End Function

    '絶対値
    Public Function Abs() As Double
        Dim DblWK As Double = 0.0
        DblWK = Math.Sqrt(Me.SquareAbs())
        Return DblWK
    End Function

    '軸に対する回転
    Public Function RotAxisLNQuat(ByVal Axis As Vector, ByVal theta As Double) As LnQuaternion
        Dim QuatWK As New LnQuaternion((Axis * (theta / 2.0)).ToNormal())
        Return QuatWK

    End Function

    '軸に対する回転
    Public Sub Axis(ByRef Axis As Vector, ByRef theta As Double)
        Dim IntWK As Integer = 0
        Dim half As Double = Abs()
        theta = 2.0 * half
        Dim sgn As Double = 1.0
        Axis = New Vector(4, True)
        If half = 0.0 Then
            Axis = Axis.UnitVec(1)
            Return
        End If
        For IntWK = 1 To 3
            Axis.x(IntWK) = q.x(IntWK - 1) / half
        Next
        Axis = Axis.NormalVec()
    End Sub


    '線形補完
    Public Function Lerp(ByVal d0 As Double, ByVal q() As LnQuaternion, ByVal d() As Double) As Quaternion
        Dim IntWK As Integer = 0
        Dim LnQuatWK As LnQuaternion = Me * d0
        For i = 0 To q.Length - 1
            LnQuatWK += q(IntWK) * d(IntWK)
        Next
        Dim Axis As New Vector(4, True)
        Dim theta As Double
        LnQuatWK.Axis(Axis, theta)
        Dim QuatWK As New Quaternion
        QuatWK = QuatWK.RotAxisQuat(Axis, theta)
        Return QuatWK
    End Function

    '線形補完
    Public Function Lerp(ByVal q As LnQuaternion, ByVal t As Double) As Quaternion
        Dim LnQuatWK As LnQuaternion = Me * (1.0 - t) + q * t
        Dim Axis As New Vector(4, True)
        Dim theta As Double
        LnQuatWK.Axis(Axis, theta)
        Dim QuatWK As New Quaternion
        QuatWK = QuatWK.RotAxisQuat(Axis, theta)
        Return QuatWK
    End Function

End Class
