﻿Imports Microsoft.Xna.Framework
Imports Microsoft.Xna.Framework.Graphics

Public Enum MessageFontType As Integer
    Normal = 0
    Title = 1
    Gradient = 2
    Outline = 3
End Enum

Public Class Paragraph
    Implements IComparable
    Implements ICloneable


    Public FontType As MessageFontType
    Public Text As String
    Public Font As SpriteFont
    Public Size As Vector2



    Public Function Clone() As Object Implements ICloneable.Clone
        Dim ret As New Paragraph
        ret.FontType = Me.FontType
        ret.Text = Me.Text
        ret.Font = Me.Font
        ret.Size = Me.Size
        Return ret
    End Function

    Public Function CompareTo(obj As Object) As Integer Implements IComparable.CompareTo
        CompareTo = 0
        Dim lh As Paragraph = Me
        Dim rh As Paragraph = obj
        Dim i As Integer
        If Not lh.Text = rh.Text Then
            CompareTo = CompareTo Or (1 << 0)
        End If
    End Function

    Public Overrides Function Equals(obj As Object) As Boolean
        Dim ret As Integer = CompareTo(obj)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Shared Operator =(ByVal lh As Paragraph, ByVal rh As Paragraph) As Boolean
        Dim ret As Integer = lh.CompareTo(rh)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Operator

    Public Shared Operator <>(ByVal lh As Paragraph, ByVal rh As Paragraph) As Boolean
        Return (Not lh = rh)
    End Operator





    Public Sub New()
        FontType = MessageFontType.Normal
        Text = ""
    End Sub

    Public Sub New(ByVal str As String)
        FontType = MessageFontType.Normal
        Text = str
    End Sub

    Public Sub New(ByVal ft As MessageFontType, ByVal str As String)
        FontType = ft
        Text = str
    End Sub
End Class
