﻿'Programed by NAS6


Imports System.Windows

Public Class SphereData
    Implements ICloneable

    Public v As Vector                  '中心座標
    Public r As Double                  '半径
    Public vcol As Color                '頂点カラー
    Public tcol As Color                '面カラー
    Public mtr As Material              '物性

    Public Sub New()
        v = New Vector(4)
        r = 0.0
        vcol = Color.White
        tcol = Color.Black
        mtr = New Material
    End Sub

    Public Sub New(ByVal pv As Vector, ByVal pr As Double, ByVal pvc As Color, ByVal ptc As Color, ByVal pm As Material)
        v = pv.Clone()
        r = pr
        vcol = pvc
        tcol = ptc
        mtr = pm.Clone()
    End Sub

    Public Function Clone() As Object Implements ICloneable.Clone
        Dim ret As New SphereData
        ret.v = Me.v.Clone()
        ret.r = Me.r
        ret.vcol = Me.vcol
        ret.tcol = Me.tcol
        ret.mtr = Me.mtr.Clone()
        Return ret
    End Function
End Class

Public Class Sphere
    Implements IComparable
    Implements ICloneable

    Public Local As New Local       'ローカル行列群
    Public v As SphereData          '球  
    Public Range As Double = 1.0    '範囲
    Public Base As Double = 2.0     '基数
    Public Label As New Label       'ラベル


    Public Function Clone() As Object Implements ICloneable.Clone
        Dim ret As New Sphere(Me.Local.Clone(), Me.v.Clone(), Me.Range, Me.Base, Me.Label.Clone())
        Return ret
    End Function

    Public Function CompareTo(obj As Object) As Integer Implements IComparable.CompareTo
        CompareTo = 0
        Dim lh As Sphere = Me
        Dim rh As Sphere = obj
        If Not (lh.Base = rh.Base) Then
            CompareTo = CompareTo Or 1
        End If
    End Function

    Public Overrides Function Equals(obj As Object) As Boolean
        Dim ret As Integer = CompareTo(obj)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Shared Operator =(ByVal lh As Sphere, ByVal rh As Sphere) As Boolean
        Dim ret As Integer = lh.CompareTo(rh)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Operator

    Public Shared Operator <>(ByVal lh As Sphere, ByVal rh As Sphere) As Boolean
        Return (Not lh = rh)
    End Operator

    Public Sub New(ByVal lcl As Local, ByVal pv As SphereData)
        Local = lcl.Clone()
        v = pv.Clone()
    End Sub

    Public Sub New(ByVal lcl As Local, ByVal pv As SphereData, ByVal rg As Double, ByVal bs As Double)
        Local = lcl.Clone()
        v = pv.Clone()
        Range = rg
        Base = bs
    End Sub


    Public Sub New(ByVal lcl As Local, ByVal pv As SphereData, ByVal lbl As Label)
        Local = lcl.Clone()
        Label = lbl.Clone()
        v = pv.Clone()
    End Sub

    Public Sub New(ByVal lcl As Local, ByVal pv As SphereData, ByVal rg As Double, ByVal bs As Double, ByVal lbl As Label)
        Local = lcl.Clone()
        Label = lbl.Clone()
        v = pv.Clone()
        Range = rg
        Base = bs
    End Sub


End Class
