﻿'Programed by NAS6


Public Class Spline
    Public MaxSplineSize As Integer = 100
    Public num As Integer
    Public a(MaxSplineSize + 1) As Double
    Public b(MaxSplineSize + 1) As Double
    Public c(MaxSplineSize + 1) As Double
    Public d(MaxSplineSize + 1) As Double

    Public Sub New()
        num = 0
    End Sub


    Public Sub init(ByVal sp() As Double, ByVal spnum As Integer)
        Dim tmp As Double
        Dim w(MaxSplineSize + 1) As Double
        Dim i As Integer

        num = spnum - 1

        '３次多項式の0次係数(a)を設定
        For i = 0 To num
            a(i) = sp(i)

        Next
        '３次多項式の2次係数(c)を計算
        '連立方程式を解く。
        '但し、一般解法でなくスプライン計算にチューニングした方法
        c(num) = 0.0
        c(0) = 0.0
        For i = 1 To num - 1
            c(i) = 3.0 * (a(i - 1) - 2.0 * a(i) + a(i + 1))
        Next
        '左下を消す
        w(0) = 0.0
        For i = 1 To num - 1
            tmp = 4.0 - w(i - 1)
            c(i) = (c(i) - c(i - 1)) / tmp
            w(i) = 1.0 / tmp
        Next
        '右上を消す
        For i = num - 1 To 0 Step -1
            c(i) = c(i) - c(i + 1) * w(i)
        Next

        '３次多項式の1次係数(b)と3次係数(b)を計算
        b(num) = 0.0
        d(num) = 0.0
        For i = 0 To num - 1
            d(i) = (c(i + 1) - c(i)) / 3.0
            b(i) = a(i + 1) - a(i) - c(i) - d(i)
        Next
    End Sub

    '媒介変数(0～num-1の実数）に対する値を計算
    Public Function calc(ByVal t As Double) As Double
        Dim j As Integer
        Dim dt As Double
        '小数点以下切捨て
        j = CType(Math.Floor(t), Integer)
        If j < 0 Then
            j = 0
        ElseIf j >= num Then
            '丸め誤差を考慮
            j = num - 1
        End If
        dt = t - CType(j, Double)
        Return a(j) + (b(j) + (c(j) + d(j) * dt) * dt) * dt
    End Function
End Class

