﻿'Programed by NAS6


'ベクトル
Public Class Vector
    Implements IComparable
    Implements ICloneable

    Public x() As Double
    Public bHomo As Boolean



    Public Function Clone() As Object Implements ICloneable.Clone
        Dim d(Me.x.Length - 1) As Double
        Dim i As Integer
        For i = 0 To Me.x.Length - 1
            d(i) = Me.x(i)
        Next
        Dim ret As Vector = New Vector(d)
        ret.bHomo = Me.bHomo
        Return ret
    End Function

    Public Function CompareTo(obj As Object) As Integer Implements IComparable.CompareTo
        CompareTo = 0
        Dim lh As Vector = Me
        Dim rh As Vector = obj
        If Not (lh.bHomo = rh.bHomo) Then
            CompareTo = CompareTo Or 1
        End If
        If Not (lh.x.Length = rh.x.Length) Then
            CompareTo = CompareTo Or 2
        End If
        Dim i As Integer
        For i = 0 To lh.x.Length - 1
            If Not lh.x(i) = rh.x(i) Then
                CompareTo = CompareTo Or (4 << i)
            End If
        Next
    End Function

    Public Overrides Function Equals(obj As Object) As Boolean
        Dim ret As Integer = CompareTo(obj)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Shared Operator =(ByVal lh As Vector, ByVal rh As Vector) As Boolean
        Dim ret As Integer = lh.CompareTo(rh)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Operator

    Public Shared Operator <>(ByVal lh As Vector, ByVal rh As Vector) As Boolean
        Return (Not lh = rh)
    End Operator


    'n次のベクトルコンストラクタ
    Public Sub New(ByVal n As Integer)
        ReDim x(n - 1)
        Dim i As Integer
        For i = 0 To n - 1
            x(i) = 0.0
        Next
        bHomo = False
    End Sub

    'doouble配列のベクトルコンストラクタ
    Public Sub New(ByVal px() As Double)
        ReDim x(px.Length - 1)
        Dim i As Integer
        For i = 0 To px.Length - 1
            x(i) = px(i)
        Next
        bHomo = False
    End Sub

    'n次のベクトルコンストラクタ（同次座標フラグ設定付き）
    Public Sub New(ByVal n As Integer, ByVal pb As Boolean)
        ReDim x(n - 1)
        Dim i As Integer
        For i = 0 To n - 1
            x(i) = 0.0
        Next
        bHomo = pb
        If bHomo Then
            x(0) = 1.0
        End If
    End Sub

    'doouble配列のベクトルコンストラクタ（同次座標フラグ設定付き）
    Public Sub New(ByVal px() As Double, ByVal pb As Boolean)
        ReDim x(px.Length - 1)
        Dim i As Integer
        For i = 0 To px.Length - 1
            x(i) = px(i)
        Next
        bHomo = pb
        If bHomo Then
            x(0) = 1.0
        End If
    End Sub

    '四則演算(便宜上も含む)
    Public Shared Operator +(ByVal lh As Vector, ByVal rh As Vector) As Vector
        Dim ret As Vector = New Vector(lh.x.Length, lh.bHomo)
        If Not lh.x.Length = rh.x.Length Then
            Return New Vector(lh.x.Length, lh.bHomo)
        End If
        Dim i As Integer = 0
        Dim l As Vector = lh.Clone()
        Dim r As Vector = rh.Clone()
        If l.bHomo Then
            i = 1
            l = l.Homogeneous()
            r = r.Homogeneous()
        End If
        For i = i To l.x.Length - 1
            ret.x(i) = l.x(i) + r.x(i)
        Next
        Return ret
    End Operator

    Public Shared Operator -(ByVal lh As Vector, ByVal rh As Vector) As Vector
        Dim ret As Vector = New Vector(lh.x.Length, lh.bHomo)
        If Not lh.x.Length = rh.x.Length Then
            Return New Vector(lh.x.Length, lh.bHomo)
        End If
        Dim i As Integer = 0
        Dim l As Vector = lh.Clone()
        Dim r As Vector = rh.Clone()
        If l.bHomo Then
            i = 1
            l = l.Homogeneous()
            r = r.Homogeneous()
        End If
        For i = i To l.x.Length - 1
            ret.x(i) = l.x(i) - r.x(i)
        Next
        Return ret
    End Operator

    '便宜上
    Public Shared Operator *(ByVal lh As Vector, ByVal rh As Vector) As Double
        Dim ret As Double = 0.0
        If Not lh.x.Length = rh.x.Length Then
            Return ret
        End If
        Dim i As Integer = 0
        Dim l As Vector = lh.Clone()
        Dim r As Vector = rh.Clone()
        If l.bHomo Then
            i = 1
            l = l.Homogeneous()
            r = r.Homogeneous()
        End If
        For i = i To l.x.Length - 1
            ret = (ret + (l.x(i) * r.x(i)))
        Next
        Return ret
    End Operator

    '便宜上
    Public Shared Operator /(ByVal lh As Vector, ByVal rh As Vector) As Double
        Dim ret As Double = 0.0
        If Not lh.x.Length = rh.x.Length Then
            Return ret
        End If
        Dim i As Integer = 0
        Dim l As Vector = lh.Clone()
        Dim r As Vector = rh.Clone()
        If l.bHomo Then
            i = 1
            l = l.Homogeneous()
            r = r.Homogeneous()
        End If
        For i = i To l.x.Length - 1
            If r.x(i) = 0.0 Then
                Return 0.0
            End If
            ret = (ret + (l.x(i) / r.x(i)))
        Next
        Return ret
    End Operator

    Public Shared Operator *(ByVal lh As Vector, ByVal rh As Matrix) As Vector
        Dim ret As Vector = New Vector(lh.x.Length, lh.bHomo)
        If (Not lh.x.Length = rh.x.Length) Or (Not lh.x.Length = rh.x(0).x.Length) Then
            Return New Vector(lh.x.Length, lh.bHomo)
        End If
        Dim l As Vector = lh.Clone()
        If l.bHomo Then
            l = l.Homogeneous()
            l.bHomo = False
            ret.bHomo = True
        End If
        Dim i As Integer
        Dim t As Matrix = rh.TransposedMat()
        For i = 0 To l.x.Length - 1
            ret.x(i) = l * t.x(i)
        Next
        Return ret
    End Operator

    Public Shared Operator /(ByVal lh As Vector, ByVal rh As Matrix) As Vector
        Dim ret As Vector = New Vector(lh.x.Length, lh.bHomo)
        If (Not lh.x.Length = rh.x.Length) Or (Not lh.x.Length = rh.x(0).x.Length) Then
            Return New Vector(lh.x.Length, lh.bHomo)
        End If
        Dim l As Vector = lh.Clone()
        If l.bHomo Then
            l = l.Homogeneous()
            l.bHomo = False
            ret.bHomo = True
        End If
        Dim i As Integer
        Dim t As Matrix = rh.TransposedMat()
        For i = 0 To l.x.Length - 1
            ret.x(i) = l / t.x(i)
        Next
        Return ret
    End Operator

    Public Shared Operator +(ByVal lh As Vector, ByVal rh As Double) As Vector
        Dim ret As Vector = New Vector(lh.x.Length, lh.bHomo)
        Dim i As Integer = 0
        Dim l As Vector = lh.Clone()
        Dim r As Double = rh
        If l.bHomo Then
            i = 1
            l = l.Homogeneous()
        End If
        For i = i To l.x.Length - 1
            ret.x(i) = l.x(i) + r
        Next
        Return ret
    End Operator

    Public Shared Operator -(ByVal lh As Vector, ByVal rh As Double) As Vector
        Dim ret As Vector = New Vector(lh.x.Length, lh.bHomo)
        Dim i As Integer = 0
        Dim l As Vector = lh.Clone()
        Dim r As Double = rh
        If l.bHomo Then
            i = 1
            l = l.Homogeneous()
        End If
        For i = i To l.x.Length - 1
            ret.x(i) = l.x(i) - r
        Next
        Return ret
    End Operator

    Public Shared Operator *(ByVal lh As Vector, ByVal rh As Double) As Vector
        Dim ret As Vector = New Vector(lh.x.Length, lh.bHomo)
        Dim i As Integer = 0
        Dim l As Vector = lh.Clone()
        Dim r As Double = rh
        If l.bHomo Then
            i = 1
            l = l.Homogeneous()
        End If
        For i = i To l.x.Length - 1
            ret.x(i) = l.x(i) * r
        Next
        Return ret
    End Operator

    Public Shared Operator /(ByVal lh As Vector, ByVal rh As Double) As Vector
        Dim ret As Vector = New Vector(lh.x.Length, lh.bHomo)
        If rh = 0.0 Then
            Return New Vector(lh.x.Length, lh.bHomo)
        End If
        Dim i As Integer = 0
        Dim l As Vector = lh.Clone()
        Dim r As Double = rh
        If l.bHomo Then
            i = 1
            l = l.Homogeneous()
        End If
        For i = i To l.x.Length - 1
            ret.x(i) = l.x(i) / r
        Next
        Return ret
    End Operator


    '内積
    Public Function Dot(ByVal rh As Vector) As Double
        Dim sum As Double = 0.0
        Dim i As Integer = 0
        Dim l As Vector = Me.Clone()
        Dim r As Vector = rh.Clone()
        If l.bHomo Then
            i = 1
            l = l.Homogeneous()
            r = r.Homogeneous()
        End If
        For i = i To l.x.Length - 1
            sum = sum + l.x(i) * r.x(i)
        Next
        Dot = sum
    End Function

    '外積
    Public Function Cross2D(ByVal rh As Vector) As Double
        If Not Me.x.Length = 2 Or Not Me.x.Length = rh.x.Length Then
            Return 0.0
        End If
        Return Me.x(0) * rh.x(1) - Me.x(1) * rh.x(0)
    End Function

    '外積
    Public Function Cross(ByVal rh As Vector) As Vector
        If Not (Me.x.Length = 3 Or Me.x.Length = 4) Or Not Me.x.Length = rh.x.Length Then
            Return New Vector(Me.x.Length, Me.bHomo)
        End If
        Dim l As Vector = Me.Clone()
        Dim r As Vector = rh.Clone()
        If Me.bHomo Then
            l = l.Homogeneous().ToNormal()
            r = r.Homogeneous().ToNormal()
        End If
        Dim d(2) As Double
        d(0) = l.x(1) * r.x(2) - l.x(2) * r.x(1)
        d(1) = l.x(2) * r.x(0) - l.x(0) * r.x(2)
        d(2) = l.x(0) * r.x(1) - l.x(1) * r.x(0)
        Dim ret As Vector = New Vector(d)
        If Me.bHomo Then
            ret = ret.ToHomo()
        End If
        Return ret
    End Function

    '原点ベクトル
    Public Function ZeroVec() As Vector
        Dim i As Integer
        Dim d0(Me.x.Length - 1) As Double
        For i = 0 To Me.x.Length - 1
            d0(i) = 0.0
        Next
        ZeroVec = New Vector(d0, Me.bHomo)
    End Function

    '単位ベクトル
    Public Function UnitVec(ByVal a As Integer) As Vector
        If Me.x.Length - 1 < a Then
            Return ZeroVec()
        End If
        UnitVec = ZeroVec()
        UnitVec.x(a) = 1.0
        If Me.bHomo Then
            UnitVec.x(0) = 1.0
        End If
    End Function

    'ノーマライズ
    Public Function NormalVec() As Vector
        Return Me / Me.Abs()
    End Function

    'ノーマライズ
    Public Function NormalVec(ByVal a As Vector) As Vector
        Dim ab As Vector = a - Me
        Return ab.NormalVec()
    End Function

    '絶対値2乗
    Public Function SquareAbs() As Double
        Dim sum As Double = 0.0
        Dim i As Integer = 0
        Dim l As Vector = Me.Clone()
        If l.bHomo Then
            i = 1
            l = l.Homogeneous()
        End If
        For i = i To l.x.Length - 1
            sum = sum + l.x(i) * l.x(i)
        Next
        SquareAbs = sum
    End Function

    '絶対値
    Public Function Abs() As Double
        Abs = Math.Sqrt(SquareAbs())
    End Function

    '方向余弦
    Public Function DirectionCosine() As Vector
        DirectionCosine = New Vector(Me.x.Length, Me.bHomo)
        Dim r As Double = Me.Abs()
        Dim i As Integer = 0
        Dim l As Vector = Me.Clone()
        If l.bHomo Then
            i = 1
            l = l.Homogeneous()
        End If
        For i = i To l.x.Length - 1
            DirectionCosine.x(i) = l.x(i) / r
        Next
    End Function

    'なす角
    Public Function Theta(ByVal rh As Vector) As Double
        Dim s As Double = 1.0
        Dim dc As Double = 0.0
        If Me.x.Length = 2 Then
            Dim crs As Double = Me.Cross2D(rh)
            If crs < 0.0 Then
                s = -1.0
            End If
        End If
        dc = Me.Dot(rh) / (Me.Abs() * rh.Abs())
        Return Math.Acos(dc) * s
    End Function

    'なす角
    Public Function ThetaN(ByVal rh As Vector) As Boolean
        Dim th As Double = Me.Theta(rh)
        If th <= -Math.PI / 2.0 Or Math.PI / 2.0 < th Then
            Return False
        End If
        Return True
    End Function

    '回転
    Public Function Rot2D(ByVal theta As Double) As Vector
        If Not Me.x.Length = 2 Then
            Return New Vector(Me.x.Length, Me.bHomo)
        End If
        Dim d0(1) As Double
        d0(0) = Me.x(0) * Math.Cos(theta) - Me.x(1) * Math.Sin(theta)
        d0(1) = Me.x(0) * Math.Sin(theta) + Me.x(1) * Math.Cos(theta)
        Return New Vector(d0)
    End Function

    '軸に対する回転
    Public Function RotAxis(ByVal axis As Vector, ByVal theta As Double) As Vector
        If Not (Me.x.Length = 3 Or Me.x.Length = 4) Or Not Me.x.Length = axis.x.Length Then
            Return New Vector(Me.x.Length, Me.bHomo)
        End If
        Dim l As Vector = Me.Clone()
        If l.bHomo Then
            l = l.Homogeneous().ToNormal()
        End If
        axis = axis / axis.Abs()
        Dim d0(2) As Double
        d0(0) = l.x(0)
        d0(1) = l.x(1)
        d0(2) = l.x(2)
        Dim v0 As Vector = (New Vector(d0)) * Math.Cos(theta)
        Dim d1(2) As Double
        d1(0) = 0.0 - axis.x(2) * l.x(1) + axis.x(1) * l.x(2)
        d1(1) = axis.x(2) * l.x(0) + 0.0 - axis.x(0) * l.x(2)
        d1(2) = -axis.x(1) * l.x(0) + axis.x(0) * l.x(1) + 0.0
        Dim v1 As Vector = (New Vector(d1)) * Math.Sin(theta)
        Dim d2(2) As Double
        d2(0) = axis.x(0) * axis.x(0) * l.x(0) + axis.x(0) * axis.x(1) * l.x(1) + axis.x(0) * axis.x(2) * l.x(2)
        d2(1) = axis.x(1) * axis.x(0) * l.x(0) + axis.x(1) * axis.x(1) * l.x(1) + axis.x(1) * axis.x(2) * l.x(2)
        d2(2) = axis.x(2) * axis.x(0) * l.x(0) + axis.x(2) * axis.x(1) * l.x(1) + axis.x(2) * axis.x(2) * l.x(2)
        Dim v2 As Vector = (New Vector(d2)) * (1.0 - Math.Cos(theta))
        Dim ret As Vector = v0 + v1 + v2
        If Me.x.Length = 4 Then
            ret = ret.ToHomo()
        End If
        Return ret
    End Function

    '軸に対する回転
    Public Function RotAxisQuat(ByVal axis As Vector, ByVal theta As Double) As Vector
        If Not (Me.x.Length = 4 And Me.x.Length = axis.x.Length) Then
            Return New Vector(Me.x.Length, Me.bHomo)
        End If
        Dim q As New Quaternion
        Dim VecWK As Vector = Me.Clone()
        VecWK = VecWK.Homogeneous()
        Dim MatWK As New Matrix(4)
        MatWK = MatWK.UnitMat()
        MatWK = q.RotAxisQuat(axis, theta).Matrix()
        VecWK = MatWK * VecWK
        Return VecWK
    End Function

    '軸に対する射影
    Public Function ProjectAxis(ByVal axis As Vector) As Vector
        If Not Me.x.Length = axis.x.Length Then
            Return New Vector(Me.x.Length, Me.bHomo)
        End If
        Return ((axis * (Me.Dot(axis))) / (axis.SquareAbs()))
    End Function

    '点と直線の距離
    Public Function DistanceDotLine(ByVal p As Vector, ByVal a As Vector, ByVal b As Vector) As Double
        Dim ab As Vector = b - a
        Dim ap As Vector = p - a
        Dim aab As Double = ab.Abs()
        Dim pab As Double = (ab.ProjectAxis(ap)).Abs()
        If aab < pab Then
            Return 0.0
        End If
        Return Math.Sqrt(aab * aab - pab * pab)
    End Function

    '直線と直線の距離と最接近位置
    Public Function DistancePointLineLine(ByRef reta As Vector, ByRef retb As Vector, ByVal a0 As Vector, ByVal a1 As Vector, ByVal b0 As Vector, ByVal b1 As Vector) As Double
        Dim f As Double = 0.0
        Dim s As Double
        Dim t As Double
        Dim ab As Vector = b0 - a0
        Dim ba As Vector = a0 - b0
        Dim nva As Vector = a0.NormalVec(a1)
        Dim nvb As Vector
        If b0 = b1 Then
            nvb = nva * -1.0
        Else
            nvb = b0.NormalVec(b1)
        End If
        If a0 = a1 Then
            If b0 = b1 Then
                reta = a0
                retb = b0
                Return ab.Abs()
            Else
                nva = nvb * -1.0
            End If
        End If
        If (nva.Dot(nvb)) * (nva.Dot(nvb)) = 1.0 Then
            reta = a0
            retb = b0
            Return DistanceDotLine(b0, a0, a1)
        Else
            s = (1.0 / (1.0 - (nva.Dot(nvb)) * (nva.Dot(nvb)))) * (nva.Dot(ab) + nva.Dot(nvb) * nvb.Dot(ba))
            t = (1.0 / (1.0 - (nva.Dot(nvb)) * (nva.Dot(nvb)))) * (nvb.Dot(ba) + nva.Dot(nvb) * nva.Dot(ab))
            f = a0.Abs() * a0.Abs() + s * s + 2.0 * s * nva.Dot(a0) + b0.Abs() * b0.Abs() + t * t + 2.0 * t * nvb.Dot(b0) - 2.0 * a0.Dot(b0) - 2.0 * s * nva.Dot(b0) - 2.0 * t * nvb.Dot(a0) - 2.0 * s * t * nva.Dot(nvb)
        End If
        reta = a0 + nva * s
        retb = b0 + nvb * t
        Return Math.Sqrt(f)
    End Function

    '直線と直線の最接近位置
    Public Function PointLineLine(ByRef reta As Vector, ByRef retb As Vector, ByVal a0 As Vector, ByVal a1 As Vector, ByVal b0 As Vector, ByVal b1 As Vector) As Boolean
        Dim d As Double = DistancePointLineLine(reta, retb, a0, a1, b0, b1)
        If Not d = 0.0 Then
            Return False
        End If
        Return True
    End Function

    '直線と直線の距離
    Public Function DistanceLineLine(ByVal a0 As Vector, ByVal a1 As Vector, ByVal b0 As Vector, ByVal b1 As Vector) As Double
        Dim reta As Vector = New Vector(a0.x.Length, a0.bHomo)
        Dim retb As Vector = New Vector(a0.x.Length, a0.bHomo)
        Return DistancePointLineLine(reta, retb, a0, a1, b0, b1)
    End Function

    '同次座標
    Public Function Homogeneous() As Vector
        Dim i As Integer
        Dim ret As New Vector(Me.x.Length, Me.bHomo)
        For i = 0 To Me.x.Length - 1
            ret.x(i) = Me.x(i) / Me.x(0)
        Next
        Return ret
    End Function

    '同次ベクトルに変換
    Public Function ToHomo() As Vector
        Dim m As Integer = 0
        Dim n As Integer = Me.x.Length
        If 3 < n Then
            m = 1
            n = 3
        End If
        Dim ret As New Vector(n + 1, True)
        Dim i As Integer
        ret.x(0) = 1.0
        For i = 0 To n - 1
            ret.x(i + 1) = Me.x(i + m)
        Next
        Return ret
    End Function

    '通常ベクトルに変換
    Public Function ToNormal() As Vector
        Dim ret As New Vector(Me.x.Length - 1)
        Dim i As Integer
        For i = 1 To Me.x.Length - 1
            ret.x(i - 1) = Me.x(i) / Me.x(0)
        Next
        Return ret
    End Function

    '回転ベクトルから回転行列
    Public Function Matrix() As Matrix
        Dim ret As New Matrix(4)
        If Not Me.x.Length = 4 Then
            Return ret.UnitMat()
        End If
        Dim mv As New Vector(4, True)
        Dim rv As Vector = Me.ToNormal().NormalVec()
        Dim th As Double = Me.x(0)
        Dim s As Double = Math.Sin(th)
        Dim c As Double = Math.Cos(th)
        Dim c1 As Double = 1.0 - c
        Dim r As New Matrix(3)
        r.x(0).x(0) = c + c1 * rv.x(0) * rv.x(0)
        r.x(0).x(1) = c1 * rv.x(0) * rv.x(1) - s * rv.x(2)
        r.x(0).x(2) = c1 * rv.x(2) * rv.x(0) + s * rv.x(1)
        r.x(1).x(0) = c1 * rv.x(0) * rv.x(1) + s * rv.x(2)
        r.x(1).x(1) = c + c1 * rv.x(1) * rv.x(1)
        r.x(1).x(2) = c1 * rv.x(1) * rv.x(2) - s * rv.x(0)
        r.x(2).x(0) = c1 * rv.x(2) * rv.x(0) - s * rv.x(1)
        r.x(2).x(1) = c1 * rv.x(1) * rv.x(2) + s * rv.x(0)
        r.x(2).x(2) = c + c1 * rv.x(2) * rv.x(2)
        ret.x(0) = mv.UnitVec(0)
        ret.x(0).bHomo = False
        Dim i As Integer
        For i = 1 To 3
            ret.x(i) = r.x(i - 1).NormalVec().ToHomo()
            ret.x(i).x(0) = 0.0
            ret.x(i).bHomo = False
        Next
        Return ret
    End Function

    '四次元球
    Public Function Sphere4D() As Quaternion
        Sphere4D = New Quaternion
        Dim i As Integer
        Dim d As Double = 0.0
        For i = 0 To 3
            d += Me.x(i) * Me.x(i)
        Next
        Sphere4D.q.x(0) = -Me.x(0) * Me.x(0)
        For i = 1 To 3
            d += Me.x(i) * Me.x(i)
        Next
        Sphere4D.q.x(0) /= d
        For i = 1 To 3
            Sphere4D.q.x(i) = 2.0 * Me.x(0) * Me.x(i) / d
        Next
    End Function

End Class

